<?
/*	Photon
	lib.php

	Main function library
	
	(c) 2005 Red Quant Corporation
	Licensed under the Open Software License version 2.1 
	See file LICENSE in the root folder of this distribution
	
*/
?>

<html>
<head>
<meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="pragma" content="no-cache">
<link rel="stylesheet" type="text/css" href="style.css">

<style>
body 	{  background-position: top, center; background-color: black; }
</style>

<?
include "globals.php";
?>

<body>
<div class=sheet>
<h2>Add Clients</h2>

<p>Clients are the sites monitored by Photon. They need to have a Webalizer or similar log analyzer running and you need to have access to the reports on the web.</p>
<p>This describes how to set up minimal ini files that suffice to use photon. You find samples and comprehensive templates in the <a href='sampleinis'>sampleinis directory</a>.

<h3>Minimal Server Ini</h3>
<p>To set up clients, first create a server ini file server.&lt;domain&gt;.ini for your installation, i.e. <? echo serverinifilename(); ?>, from the template below. If there is more than one http path to your installation, e.g. photon.yourhost.com and yourhost.com/photon, you need to have an alias or a second copy of this file, e.g. server.photon.yourhost.com.ini and server.yourhost.com.ini. For details please look at the commented <a href='sampleinis/server.template.ini'>full template</a> and <a href='sampleinis/server.sample.ini'>full sample</a> for a server ini file.<br><br>
If it can't find the server.&lt;domain&gt;.ini file, Photon uses server.generic.ini. You might want to leave that file intact as a fallback.<br><br>
To get started, simply replace &lt;client id&gt; with any id for the first client, e.g. COMPANY1, and &lt;user id&gt; with a log in for someone to use Photon, e.g. mike, and copy and paste the text below to the file <? echo serverinifilename(); ?>. 

<pre>
<?
$t = file_get_contents("sampleinis/server.template-brief.ini");
echo(htmlentities($t));
?>
</pre>
The user needs to be added to .htpasswd with htpasswd:
<pre>
<?
$proot = dirname($_SERVER['SCRIPT_FILENAME']);
echo("htpasswd $proot/.htpasswd &lt;user id&gt;");
?>
</pre>
e.g. <? echo("htpasswd $proot/.htpasswd mike. Again, use find / -name htpasswd to locate the program if it is not found in the path."); ?>
<br>
<br>
Photon will now understand that this user belongs to this client and what client.*.ini must be loaded, which we will create next. The Scanner section for Webalizer is explained in more detail in the <a href='sampleinis/server.template.ini'>full template</a> for a server ini file, also, how this section looks for other log analyzers, i.e. Analog and AWStats.
<br>
<br>
<h3>Client ini</h3>
Now you create a client ini file inis/client.&lt;client id&gt;.ini named after the &lt;client id&gt; from above. Preferrably written in lowercase now for optical consistency, e.g. client.company1.ini. The client ini needs to yield the information where the log analyzer report is found, e.g. http://myhoster/webalizer/web9/usage_2000512.html. The year and month parts are encoded with %yyyy and %mm. See the brief sample below and the <a href='sampleinis/client.template.ini'>full template</a> and the <a href='sampleinis/client.template.ini'>full sample</a> for details. When your reports' URL is password protected, you may state the login in the URL, e.g. http://loguser:logpass@myhoster ... The login us stored in the ini file then, which is a security issue if this is the login for your hosting account management tool. To be safe, you could copy the reports to another place on the web and enter that URL in the client ini file.<br><br>Copy and paste the below template and insert the appropriate data. You may copy the PRESETS section from the sample shown below the template, as is. Save the result to inis/client.&lt;client id&gt;.ini
<pre>
<?
$t = file_get_contents("sampleinis/client.template-brief.ini");
echo(htmlentities($t));
?>
</pre>

<h5>Client ini sample (sampleinis/client.sample-brief.ini) 
<pre>
<?
$t = file_get_contents("sampleinis/client.sample-brief.ini");
echo(htmlentities($t));
?>
</pre>
<p>Reload this page when done and start using your installation.</p>

</div>
</body>




