<?
/*	Photon
	data.php

	Retrieve and prepare statistics data for Flash stats generator

	(c) 2005 Red Quant Corporation
	Licensed under the Open Software License version 2.1 
	See file LICENSE in the root folder of this distribution
	
*/	
	
	
ini_set('display_errors', true); 
ini_set('error_reporting', E_ALL); 
ini_set('max_execution_time', 10*60); 

define('FILE_BUFFER_SIZE', 1000000);     // 1MB

define('PRESET_PARSER', "/([^:]+):(?".">\s+)(.+)/");

include("lib.php");


function testsheader()
{
	echo '<link rel="stylesheet" type="text/css" href="style.css">';
}


/* didn't work
error_reporting(E_ALL);
	
$old_error_handler =set_error_handler ("chartErrorHandler" ); 

function chartErrorHandler ($errno ,$errmsg ,$filename ,$linenum ,$vars )
{
	errexitgraph("$errmsg ($errno) $filename $linenum");
}

$x = $y;
*/


// *************************************************************************
// TESTS 
// *************************************************************************
// Testqueries with text output for direct call of this file
// *************************************************************************

if(isset($_REQUEST['display']))
// accepted formats:
// ?display=1,200510 or 
// ?display=200510 or 
// ?display or 
// ?display=0,200510,Total+Hits
{
	$i = 0;
	$tag = 200510;
	$var = null;
	$a = explode(",", $_REQUEST['display']);
	if(count($a) == 1) { $tag = $a[0]; }
	else if(count($a) == 2) { $i = $a[0]; $tag = $a[1]; }
	else if(count($a) == 3) { $i = $a[0]; $tag = $a[1]; $var = urldecode($a[2]); }
	display($i, $tag, $var);
}

if(isset($_REQUEST['displaysum']))
// accepted format: 
// ?displaysum
// ?displaysum=200510,Total+Hits
{
	$tag = 200509; 
	$var = "Total Visits";
	$a = explode(",", $_REQUEST['displaysum']);
	if(count($a) == 2) { $tag = $a[0]; $var = urldecode($a[1]); }
	else echo "using defaults ";
	
	busylog("Display Sum Command: $tag $var", 1);	
	echo "$tag $var: ";
	echo ($r = getSummedScalar($tag, $var));
	busylog("$r", -1);	
}

if(isset($_REQUEST['displaypreset']))
// accepted format: 
// ?displayset
// ?displayset=200510,Visits
{
	$tag = 200509; 
	$preset = "Visits";
	$a = explode(",", $_REQUEST['displaypreset']);
	if(count($a) == 2) { $tag = $a[0]; $preset = urldecode($a[1]); }
	else echo "using defaults ";

	busylog("Display Preset: $tag $preset", 1);	
	echo "$tag $preset: ";

	if(!isset($inis['PRESETS'])) errexit("Missing Evaluations section in ini file.");

	$execute = isset($inis['PRESETS'][$preset]) ?
					 $inis['PRESETS'][$preset] : false;

	if(!$execute) errexit("Invalid preset '$preset'.");
	busylog("$preset definition found: $execute");	

	if(preg_match(PRESET_PARSER, $execute, $match))
	{
		$name = $match[1];
		$scanpattern = $match[2];
		busylog("Extract name, scan patter: '$name', '$scanpattern'");	
	}
	else 
		errexit("Invalid preset definition for '$preset':\n$execute");
	
	$r = getSummedScalar($tag, $scanpattern);
	busylog("$r", -1);	
	echo ($r);
	
	dumpbusysnap();

}


if(isset($_REQUEST['12month']))
// accepts 
// ?12month
{

	$pattern = "Total Visits";
	$arr = make12monthtags(time());
	

	xlog("<b>$pattern</b>");
	foreach($arr[0] as $i => $a)
	{
		xlog("Month $i - ".$arr[1].": " . getSummedScalar($a, $pattern));
	}
}

if(isset($_REQUEST['showgrid']))
// accepts 
// no params
{
	testsheader();

	buildsourcegrid(VERBOSE);
	
	exit();
}


// *************************************************************************
// Referrer List
// *************************************************************************

$referrerlist = isset($_REQUEST['referrerlist']);
if($referrerlist)
{
	testsheader();

	echo(I("Updating list of referrers ...<br><br>"));
	macflush();
	
	$refcompendium = array();
	buildrefcompendium($refcompendium, NON_VERBOSE);

	echo(I("Referrer list completed.<br><br>"));
	macflush();

	?>
	<script>
	parent.parent.menuframe.location.reload();
	</script>
	<?
	
	phone(3, "Referrer List creation");
	exit();
}


if(isset($_GET['colortest'])) // for call via readfile by panel.php
{
	colortest();
	exit();
}

// *************************************************************************
// URL list for Referrers
// *************************************************************************
if(isset($_GET['trend'])) // for call via readfile by panel.php
	$showtrend = $_GET['trend'] == "on";
else 
	$showtrend = isset($_COOKIE['trend']) && $_COOKIE['trend'] == "on";

$referrerurls = isset($_REQUEST['output']) ? ($_REQUEST['output'] == "referrerurls") : false;

if($referrerurls)
{
	$anyurlsprinted = false;
	
	includestyle();

	startsheet("margin-left: 50; width:680; background-position: top center;"); // ((4))

	$presetparam = isset($_REQUEST['preset']) ? $_REQUEST['preset'] : "";
	$presets = explode(",", $presetparam);
	$refcompendium = null;
	
	// DEBUG buildsourcegrid(VERBOSE, DO_TESTS); 
	buildsourcegrid(NON_VERBOSE, NO_TESTS); 


	foreach($presets as $preset)
	{
		if(isset($evalgrid[$preset]))
			;
		else 
		{
			// Pull only if needed.
			if($refcompendium === null)
			{
				retrievecompendium("referrer", $refcompendium, REF_COMPENDIUM_VERSION);
			
				if($refcompendium === null)
				
					buildrefcompendium($refcompendium);			
			
			}	

			if(isset($refcompendium[$preset]))
			{
					$anyurlsprinted = true;

					echo("<table>");
					echo "<span class=descriptive>"
					. I("List of referring pages", "stageschool")
					. "</span>";

					$name = $refcompendium[$preset]['name'];
					$urls = $refcompendium[$preset]['urls'];
					$searcherlink = "";
					// (linked_icon(ICON_SOURCEPAGE, 
					//	makeSELink(key($refcompendium[$preset]['hosts'])),
					//		"sourceinspect", "help"));

					$stackerswitch = ""; 
					// would need url from outside readfile
					
					// **********************
					// list found urls
					// **********************
					$ii = 0;
					$colorii = 0;
					$hitmax =  0;
					foreach($urls as $url => $hits)
						$hitmax = max($hitmax, $hits['sum']);  
					$threshold = ceil($hitmax/100);

					foreach($urls as $url => $hits)
					{
						echo "<tr><td style=width:200>";
						echo $searcherlink;
						echo " <b>$name</b> ";
						
						echo "</td>";
						echo "<td>";
						echo linked_icon(ICON_SOURCEPAGE, $url,
								"sourceinspect", "help");
						echo " <a href='$url' target='sourceinspect'>$url</a>";
						echo "</td>";
						echo "<td>". $hits['sum']."</td>";
						echo "<td>". $stackerswitch ."</td>";
						if(!$showtrend) // automatically stacked then below (2) 
							echo "<td>"
							. colorsample(  
								(count($urls) <= 20 || $hits['sum'] > 10) ? $colorii++ : -1)
							."</td>";
						echo "</tr>";
						$ii++;
						$name = ""; // put only in first row.
						$searcherlink = "";
						$stackerswitch = "";
					}	

					echo "</table>";
					
					// Search Engine Potential-Research
					if(useSE()) // checks if configured in inis
					{
						echo "<hr>";
						
						
						$host = key($refcompendium[$preset]['hosts']);
						
						echo "<span class=descriptive>"
							. sprintf(I("%s research. These pages at %s mention or link to %s."),
								SEARCH_ENGINE_NAME,
								$host,
								htmlentities(strtolower(
									SEARCH_ENGINE_SEARCH_TERM)))
								 // for < > work around, see lib.php (5) 
							. "</span>";
						echo "<table>";
	
						// **********************
						// search engine research
						// **********************
	
						$finds = grepSE($host);
						if($finds)
							foreach($finds as $url)
							{
								$url = "http://" . $url;
							
								echo "<tr><td style=width:200>";
								echo " <b>$host</b> ";
									
								echo "</td>";
								echo "<td>";
								echo (linked_icon(ICON_SEARCHPAGE, $url,
										"sourceinspect", "help"));
								echo " <a href='$url' target='sourceinspect'>$url</a>";
								echo "</td>";
								echo "</tr>";
								$host = ""; // put only in first row.
							}
						else
							if($finds === NO_FINDS) // must be === !
								echo(sprintf(I(
									"No finds."), 
									SEARCH_ENGINE_NAME));
							else
								echo(sprintf(I(
									"Could not perform search at %s."), 
									SEARCH_ENGINE_NAME));
				
						echo("</table>");		

				} // eo Search Engine
			}
			else
				errexit("Invalid preset '$preset'.");
		}
	}

	if($anyurlsprinted) // note: startsheet ist always done at (4)
	{
		// Make black spacer line and 're-start' sheet.
		echo( "</div><div class=innersheetspacer><br></div><div class=innersheet>");

		// This all counts on the subsequent call of data.php
		// for the extended statistics. A stupid waste.
	}
	
	
	dumpbusysnap("Table output", DONT_ECHO, WRITE_IT);
		// really SNAP dump, not whole log
		// APPEND, because table is simply called after flash.

	exit();
}

//include charts.php to access the SendChartData function
include "phpswfcharts/charts.php";

// *************************************************************************
// Read preset, retrieve data and prepare for chart generator
// *************************************************************************

$presetparam = isset($_REQUEST['preset']) ? $_REQUEST['preset'] : "";
$textoutput = isset($_REQUEST['output']) ? ($_REQUEST['output'] == "text") : false;

// $stacked = isset($_REQUEST['stacked']);
$stacked = false;

if($presetparam)
{
	global $evalgrid;

	// test
	if($presetparam == "test") errexitgraph("Engine Test.");

	// Compare against
	$compare = isset($_COOKIE['compare']) ? $_COOKIE['compare'] : false;
	if($compare 
	&& !preg_match("/\b".preg_quote($compare,"/")."\b/", $presetparam))
	// not already in the presetparam. 
	// But take care with preg_match to allow Google with GoogleUS.
		$presetparam = $compare . "," . $presetparam;

	// DEBUG buildsourcegrid(VERBOSE, DO_TESTS); 
	buildsourcegrid(NON_VERBOSE, NO_TESTS); 

	// Furbish Referrer compendium.
	$refcompendium = null;

	$months = make12monthtags(time());
	define('AXIS_VALUES', 0); // 0-Index der ersten Spalte,
	$columnset = 1;			  // Startwert im selben Indexbereich.	
	$colorset = 1;			  // Counted separately for sack skipping.	
	
	$chart[ 'chart_data' ] = array ();
	$chart [ 'chart_type' ] = array (); 

	$chart[ 'chart_data' ] [AXIS_VALUES] = $months[MONTH_NAMES];

	busylog("*** Retrieving data: $presetparam **");
	$presets = explode(",", $presetparam);
	$max = 0;
	$iterations = 1;
	$npresets = count($presets);
	$therewasadefinhere = false;
	$sack = null;
	
	// *****************
	// Loop over presets
	// *****************
	
	foreach($presets as $preset)
	{
		
		// Sort out what the data source is and 
		// if a sub loop through each url of a referrer is 
		// requested. Pull referrer compendium if needed.
		// -----------------------------------------------
		if(isset($evalgrid[$preset]))
		{
			$take = "def";
			$therewasadefinhere = true;
			$stacked = false;
			$subloops = array(""); // just once through subloop.

			if(isset($evalgrid[$preset]['error']))
				errexitgraph($evalgrid[$preset]['error']);
		}
		else 
		{
			// Pull only if needed.
			if($refcompendium === null)
				retrievecompendium("referrer", $refcompendium, REF_COMPENDIUM_VERSION);
				
			// debug print_r($refcompendium);
	
			if(isset($refcompendium[$preset]))
			{
				if(!$showtrend && count($refcompendium[$preset]['urls']) > 1)
					if(!$therewasadefinhere)
						$stacked = true; // ((2))

				if($stacked)
				{
					$take = "stackedref";
					$subloops =& $refcompendium[$preset]['urls']; 
				}
				else
				{
					$take = "ref";
					$subloops = array(""); // just once through subloop.
				}
			}
			else
				errexitgraph("Invalid preset '$preset'.");
		}
		
		foreach($subloops as $url => $urldata)
		{
			$chart[ 'chart_data' ] [$columnset] = array();
	
			// Forecast
			if(isset($_COOKIE['forecast']) && $_COOKIE['forecast'])
				$ifc = getforecastcandidate($chart[ 'chart_data' ][0]);
			else
				$ifc = false;
				
	
			$chartclearname = ($take == "ref" || $take == "stackedref" ?
							 $refcompendium[$preset]['name'] :
							 $evalgrid[$preset]['name']);
	
	
			// Unite gray columns
			$putintosack = false;
			if($take == "stackedref")
				if($refcompendium[$preset]['urls'][$url]['sum'] <= 10
					&& count($subloops) > 20)
					$putintosack = true;


			// ****************
			// Loop over months
			// ****************
			
			foreach($months[MONTH_TAGS] as $im => $month)
			{
				$clearname = $chartclearname
							 . " " . $months[MONTH_NAMES][$im];
				
				$gauge = str_repeat("&bull;", $iterations++);
				sendtostatusbar($gauge . " " . $clearname);
	
	
				if($take == "def")
				{
					// Go retrieve. Cascades down in cache or report retrieval.
					$v = getSummedScalar($month, 
						$evalgrid[$preset]['pattern'],
						$preset, $clearname, 
						$evalgrid[$preset]['scannerid'],
						$evalgrid[$preset]['alternate']);
					$clearsubname = "";
				}
				else if($take == "ref")
				{
					$v = isset($refcompendium[$preset][$month]) ?
						$refcompendium[$preset][$month] : 0;
					$clearsubname = "";
				}
				else if($take == "stackedref")
				{
					$v = isset($refcompendium[$preset]['urls'][$url][$month]) ?
						$refcompendium[$preset]['urls'][$url][$month] : 0;
					$clearsubname = $url;
				}
				else
					die();
		
				if($ifc === $im)
				{
					if($v) // if zero, leave that. Esp.for stacked url'd charts
					{
						$vv = forecast($v, $ifc);
						note("$clearname $clearsubname forecast $vv from $v today.");
						$v = $vv;
					}
					$chart[ 'chart_data' ] [0] [$im] .= "\restimated";
				}
				
				// Set value for column
				$sackedrightnow = false;
				if(!$putintosack)
				{
					$chart[ 'chart_data' ] [$columnset] [$im] = $v;
					$usecolumn = $columnset;
				}
				else
				{
					// Collect into sack. Create now if none there.
					if($sack == null)
					{
						$sack = $columnset;
						$chart[ 'chart_data' ] [$sack][0] = "";
							// OTHERS ARE SHIFTED (10)
						$sackedrightnow = true;	
					}
					if(isset($chart['chart_data'][$sack][$im+1])) 
						// +1 because sacks are not shifted
						$chart['chart_data' ] [$sack] [$im+1] += $v;
					else
						$chart['chart_data' ] [$sack] [$im+1] = $v;
				
					$usecolumn = $sack;
				}
	
			} // eo month loop
	
			$max = max(max($chart[ 'chart_data' ] [$usecolumn]), $max);
			
			if(!$putintosack) 
			{
				array_unshift($chart[ 'chart_data' ] [$columnset],
					$clearsubname ? "" : $chartclearname); 	// ((10))

				$chart [ 'series_color' ] [$columnset] = color($colorset++ -1);
			}
			else
			{
				$chart [ 'series_color' ] [$sack] = color(-1);
			}
			
			if(!$stacked) 
				$chart [ 'chart_type' ][] = "column"; // Sacks never coexist with this
			else
				$chart [ 'chart_type' ] = "stacked column"; 
	

			if(!$putintosack || $columnset == $sack)
				$columnset++;
				
			$sackedrightnow = false;
		
		} // eo subloop (referrer urls)
	} // eo preset loop	

	
	// Insert maximum for chart formatting.
	array_unshift($chart[ 'chart_data' ] [AXIS_VALUES], $max); 
	sendtostatusbar("Done retrieving data.");

}


// *************************************************************************
// Samples: Retrieve data and prepare for chart generator
// *************************************************************************

// Sample array for chart generator, w/o real data
if(isset($_REQUEST['samplechart1']))
{
	$chart [ 'chart_data' ] = 	
 		array ( array ( "",         "2001", "2002", "2003", "2004" ),
		array ( "Region X",     5,     10,     30,     63  )
	); 
}

// Sample array for chart generator, w real data
else if(isset($_REQUEST['samplechart2']))
{
	$pattern = "Total Visits";
	$arr = make12monthtags(time());
	$chart [ 'chart_data' ] = array ();
	$chart[ 'chart_data' ] [0] = $arr[1];

	foreach($arr[0] as $i => $a)
	{
		$chart[ 'chart_data' ] [1] [] = getSummedScalar($a, $pattern);
	}

	$max = max($chart[ 'chart_data' ] [1]);
	array_unshift($chart[ 'chart_data' ] [0], $max);
	array_unshift($chart[ 'chart_data' ] [1], "Visitors");

	$chart[ 'chart_value_text' ] =  
		$chart[ 'chart_data' ]; 
	$chart[ 'chart_value_text' ][1] = 
		$chart[ 'chart_data' ][1];

}

// *************************************************************************
// Text output with additional stats
// *************************************************************************
if($textoutput)
{
//	includestyle();
//	startsheet();
	
	$a = preptrendsetc(
		array($chart[ 'chart_data' ][0], $chart[ 'chart_data' ][1]));
		// cuts of multiple columns
	printmulticolumntable($a);

	echo(nl2br(note()));

	endsheet();
	
	dumpbusysnap("Table output", DONT_ECHO, WRITE_IT);
		// really SNAP dump, not whole log
		// APPEND, because table is simply called after flash.
}
else


{

// *************************************************************************
// Trend (3 months)
// *************************************************************************
	if($showtrend && !$stacked)
	{
		// Calculate trend
		$trendcol = count($chart[ 'chart_data' ]); // == +1 index
		$sourcecol = count($chart[ 'chart_data' ]) - 1; // == last index
		$chart[ 'chart_data' ][$trendcol][0] = 
			$chart[ 'chart_data' ][$sourcecol][0] . " Trend";
		$chart[ 'chart_value_text' ][$trendcol][0] = null;
		$cc = count($chart[ 'chart_data' ][$sourcecol]);
		$avg3 = $pre = $prepre = 0;
		
		// Forecast
		if(isset($_COOKIE['forecast']) && $_COOKIE['forecast']) // sic!
			$ifc = false; // don't DOUBLE forecast. 
						 // When forecast flag is set, it's already done.
		else
			$ifc = getforecastcandidate($chart[ 'chart_data' ][0]);

		if($ifc) $forecast =
			forecast($chart[ 'chart_data' ][$sourcecol][$ifc], $ifc);
	
		for($i = 1; $i < $cc; $i++)
		{
			$v = $chart[ 'chart_data' ][$sourcecol][$i];
			if($i == $ifc) $v = $forecast;
	
			$trend = ceil(($v+$pre+$prepre) / min(3, $i));
			
			$chart[ 'chart_data' ][$trendcol][$i] = $trend;
			$chart[ 'chart_value_text' ][$trendcol][$i] = $trend;
		
			$prepre = $pre;
			$pre = $v;
		}
		$chart [ 'chart_type' ][] = "area"; 

	}

// *************************************************************************
// Forecast columns (doesn't work with chart engine, needs a fix)
// *************************************************************************

	
	// Forecast
	if($showforecast = false)
	{
		$forecastcol = 3;
		$chart[ 'chart_data' ][$forecastcol][0] = "Forecast";
		$chart[ 'chart_value_text' ][$forecastcol][0] = null;
		$cc = count($chart[ 'chart_data' ][1]);
		$ifc = getforecastcandidate($chart[ 'chart_data' ][0]);
		if($ifc) $forecast = forecast($chart[ 'chart_data' ][1][$ifc], $ifc);

		for($i = 1; $i < $cc; $i++)
		{
			$v = ($i == $ifc) ? $forecast : 0;
			$l = ($i == $ifc) ? $forecast : "";
			$chart[ 'chart_data' ][$forecastcol][$i] = $v;
			$chart [ 'chart_value_text' ][$forecastcol][$i] = $l;
		}
	}
	
// *************************************************************************
// Configure stats graphics
// *************************************************************************

	//	$chart [ 'chart_value_text' ] = $chart [ 'chart_data' ]; 


		// Format chart
		$chart [ 'legend_label' ] = array (   // 'layout'  => string , 
                                      'bullet'  => "square",
                                      'font'    => "Arial", 
                                      'bold'    => true, 
                                      'size'    => 12, 
                                      'color'   => "e0ffff" , 
                                      'alpha'   => 100 ); 
                                      
		$chart [ 'axis_value' ] = array (   'min'           =>  0,  
										'max'           =>  0, 
										'steps'         =>  10,  
										'prefix'        =>  "", 
										'suffix'        =>  "", 
										'decimals'      =>  0,
										'decimal_char'  =>  ",",
										'separator'     =>  ".", 
										'show_min'      =>  true, 
										'font'          =>  "Arial", 
										'bold'          =>  true, 
										'size'          =>  12, 
										'color'         =>  "ffffff", 
										'alpha'         =>  75,
										'orientation'   =>  ""
									   ); 
	
		$chart [ 'axis_category' ] = array (   'skip'         =>  0,
										   'font'         =>  "Arial", 
										   'bold'         =>  true, 
										   'size'         =>  10, 
										   'color'        =>  "ffffff", 
										   'alpha'        =>  100,
										   'orientation'  =>  "horizontal"
									   ); 
										  
		$chart [ 'chart_value' ] = array (  'prefix'         =>  "", 
										'suffix'         =>  "", 
										'decimals'       =>  0,
										'decimal_char'   =>  ".",  
										'separator'      =>  ",",
										'position'       =>  "outside",
										'hide_zero'      =>  false, 
										'as_percentage'  =>  false, 
										'font'           =>  "Arial", 
										'bold'           =>  true, 
										'size'           =>  9, 
										'color'          =>  "000000", 
										'alpha'          =>  100
										
										);

	$ccc = count($chart [ 'chart_data' ]);
	if($npresets == 1)										
		// $chart [ 'series_gap' ] = array (   'bar_gap'  =>  0,
		//									'set_gap'  =>  2
		//								);                                     
	if($npresets == 2 && !$showtrend)										
		$chart [ 'series_gap' ] = array (   'bar_gap'  =>  -80,
		 									'set_gap'  =>  50
										);                                     
	if($npresets == 2 && $showtrend)										
		$chart [ 'series_gap' ] = array (   'bar_gap'  =>  -60,
											'set_gap'  =>  40
										);                                     
	
	$chart [ 'chart_rect' ] = array (   'x'               => 50 , 
//                                    'y'               =>  ,
                                    'width'           => 680 
//                                    'height'          => int ,
//                                    'positive_color'  => string ,
//                                    'negative_color'  => string ,
//                                    'positive_alpha'  => int ,
//                                    'negative_alpha'  => int 
	); 

	$chart [ 'legend_rect' ] = array ( 'x'               => 50 ,
//                                     'y'               => int , 
                                       'width'           => 680 , 
//                                     'height'          => int , 
//                                     'margin'          => int ,
                                       'fill_color'      => "202020" ,
                                       'fill_alpha'      => 100, 
                                       'line_color'      => "e0e0e0e" ,
                                       'line_alpha'      => 100 , 
                                       'line_thickness'  => 1 
	);

	// Add notes of omission, retrieval problems.
	if(note())
	{
		 $notes = str_replace("\n", "\r", note());
		 
		 $chart [ 'draw' ] = array (
	
								 
								array ( 'type'       => "text",
										'h_align'    => "left", 
										'x'			 => 50,
										'y'			 => 365,
										'v_align'    => "top", 
										'text'       => $notes,  
										'font'       => "Arial", 
										'bold'       => true, 
										'size'       => 10, 
										'color'      => "505050", 
										'alpha'      => 100
									  )
							  ); 
	   
	
	}
	
	dumpbusysnap("chart output", DONT_ECHO, WRITE_IT); // really SNAP dump, not whole log
	
	// *************************************************************************
	// Send the data to the flash generator
	// *************************************************************************
	 
	sendtostatusbar("Populating chart.");
	SendChartData ($chart);
	//  Format:
	//  string InsertChart ( string flash_file, string library_path, 
	//	string php_source [, int width [, int height [, string color
	//					  [, boolean transparent ]]]] ) 

}

dumpbusysnap(DONT_ECHO, WRITE_IT); // really SNAP dump, not whole log
sendtostatusbar("");


?> 