<?
/*	Photon
	globals.php

	Definitions used by scripts that don't need the full lib.php.
	
	(c) 2005 Red Quant Corporation
	Licensed under the Open Software License version 2.1 
	See file LICENSE in the root folder of this distribution

*/

define('PROGRAM',	'Photon');
define('VERSION', "1.0.1");
define('REF_COMPENDIUM_VERSION', "1");

define('COPYRIGHT',	'(C) 2006 Red Quant Corporation');
define('HTMLCOPYRIGHT',	'&copy; 2006 Red Quant Corporation<br>Licensed under the Open Software License version 2.1');
define('BRIEFCOPYRIGHT',	'2006 Red Quant');
define('BRIEFPOWERED',	'authentic internet');
define('HTMLBRIEFPOWERED',	'<a href=http://authinc.com target=ai>authentic internet</a>');


define('LOGDIR',   "logs");
define('CACHEDIR', "cache");	// lib, lib-setuptest
define('ISCHART',  true);		// line() (menu.php)

define('SELFTEST_SWITCH_FILE', "logs/selftest.switch");
define('SELFTEST_OK_FLAG_FILE', "logs/selftest-ok.flag");
define('SETUP_COMPLETED_ONCE_FLAG_FILE', "logs/setup-completed-once.flag");
define('TEST_FILE', "test");

define('ICON_BARCHART', "photon.button.1.barchart.x2.png");
define('ICON_SOURCEPAGE', "icon.window.9.png");
define('ICON_SEARCHPAGE', "icon.searched.window.9.png");

define('PHPSWFCHARTS_MAINDIR', "phpswfcharts");
define('PHPSWFCHARTS_MAINFILE', "phpswfcharts/charts.php");
define('PHPSWFCHARTS_VERSION', "4.5");

function statusfilename($user) 
{ 
	return  LOGDIR . "/" . $user. ".status"; 
}	

function startsheet($style="")
// Start logg and tests sheets
{
	echo("<div class=logdata style='$style'><div class=innersheet>");
}

function endsheet()
// End logg and tests sheets
{
	echo("</div></div>");
}

function cachename($type, $source, $tag, $uniquer=null, $crossclient=false)
{
	global $client;
	
	$md5 = ($uniquer?substr(md5($uniquer),0,8):"");

	$dir = cachedir($client && !$crossclient ? $client : "");	
	return($dir		. "/$type"
					. ($crossclient?"":".".$client)
					. ($source?".".$source:"")
					. ($tag?".".$tag:"")
					. ($md5?".".$md5:""));
}

function cachedir($client)
{
	$dir = CACHEDIR	. ($client ? "/" . $client : "");

	// Create cache dir on the fly if necessary.
	if($dir !== CACHEDIR)
		if(!is_dir($dir))
			mkdir($dir);

	return $dir;	
}

function button($prompt, $url, $javascript, $name="button", $id="button")
{
//	echo("<button name='$name' id='$id' onclick='$javascript'>$prompt</button>");
	$javascript = str_replace('"', '\"', $javascript); 
	echo("<form method=get><input type=button value=\"$prompt\" onclick=\"$javascript\"></form>");
}

function longversionstring()
{
	$v = "v " . VERSION;
	$v .= " - " . date("d M y", 
		max(
			filemtime("globals.php"),
			filemtime("lib.php"),
			filemtime("data.php")));

	return $v;

}

function serverinifilename($override=null)
{
	$id = $override ? $override :
			str_replace("www.", "", $_SERVER['SERVER_NAME']);
	return 	"server.$id.ini";
}

function clientinifilename($client)
{
	return "inis/client." . $client . ".ini";
}

function writecompendium($id, &$compendium, $version)
{
	// Make sure version is in compendium
	$compendium['version'] = $version;

	$flat = serialize($compendium);
	$fp = fopen(sername($id), "w");
	fwrite($fp, $flat);
	fclose($fp);

	// to allow menu to use this very array.
	// It's passed into the function as reference,
	// that's default for arrays.
	unset($compendium['version']);

}

function retrievecompendium($id, &$compendium, $version)
{
	$fn = sername($id);
	if(!file_exists($fn))
	{
		$compendium = null;
		return;
	}

	$fp = fopen($fn, "r");
	$flat = fread($fp, filesize(sername($id)));
	fclose($fp);
	$compendium = unserialize($flat);
	
	// Check version, kill if wrong
	if($compendium['version'] != $version)
		$compendium = null;
}

function compendiumtimedout($id)
{
	$fn = sername($id);
	if(!file_exists($fn)) return true;
	
	$cache_allowed_age = max(CACHE_ALLOWED_AGE, 2*60); // 2 min minimum
	if(filemtime($fn) < time() - $cache_allowed_age)
		return true;
		
	return false; // aka not timed out, good to use

}

function sername($id)
{
	global $client;
	return cachedir($client) . "/$id.$client.ser";
}

function linked_icon($icon, $link, $t)
{
	return "<a href='$link' target='$t'><img src='images/$icon' border=0></a> ";


}

// For returned array of make12monthtags()
define('MONTH_TAGS', 0);
define('MONTH_NAMES', 1);

function make12monthtags($time)
// Create an array of tags '200510' etc 12 months backward from time
// and clear name (abrev.) 'Oct 05'
// Labels are internationalized
{
	$date = getdate($time);
	$month = $date["mon"];
	$year = $date["year"];
	$startyear = $year;
	$r = array(); // tags 200510
	$h = array(); // human readable Oct 2005
	
	for($i = 11; $i >= 0; $i--)
	{
		$r[$i] = sprintf("%04d%02d", $year, $month);	
		$h[$i] = I(date("M", mktime ( 12,0,0, $month, 1, $year)))
			. " " . date("y", mktime ( 12,0,0, $month, 1, $year)); 
		// 12 to avoid any DST problems

		
		$month--;
		if($month < 1) { $month = 12; $year--; }
		if($year < 1000) { $year = $startyear; }
		if($year > 9999) { $year = $startyear; }
	}
	
	ksort($r); // reverse, as it is created going back in time.
	ksort($h); // "
	// print_r($r);
	return (array ($r, $h));
}

function make1monthtag($time)
// Create a tag '200510' and clear name (abrev.) 'Oct 05'
// Labels are internationalized
{
	$date = getdate($time);
	$month = $date["mon"];
	$year = $date["year"];
	
	// tags '200510'
	$r = sprintf("%04d%02d", $year, $month);	
	// human readable 'Oct 2005'
	$h = I(date("M", mktime ( 12,0,0, $month, 1, $year)))
			. " " . date("y", mktime ( 12,0,0, $month, 1, $year)); 
		// 12 to avoid any DST problems

	return (array ($r, $h));
}

function color($i)
{
	if($i == -1) $c = "eeeebb";
	else if($i == 0) $c = "ddbb60";
	else if($i == 1) $c = "B0C4DE";
	else
	{
		$i = $i -1;
		$g = 50 * $i % 256; //(256 / 3) * ($i % 3);
		$b = 100 * $i % 256;
		$r = (80 * $i) % 256;

		$c = sprintf("%02x%02x%02x", $r, $g, $b);	
	} 

	return $c;
	// echo("<div style=background-color:$c>Hello</div>");
}


function colortest()
{
	for($i = 0; $i < 25; $i++)
		echo("<div style=background-color:".color($i).">Hello</div>");
}


?>