<?
/*	Photon
	lib-tests.php

	Test function library
	
	(c) 2005 Red Quant Corporation
	Licensed under the Open Software License version 2.1 
	See file LICENSE in the root folder of this distribution
	
*/

define('AS_PARAGRAPH',	true); // testerror

function runSampleFiles($samplefiles, $pattern, $scannerid, $patternid)
{
	$files = explode(",", $samplefiles);
	$anysuccess = false;
	foreach($files as $fn)
	{
		echo("<p class=tests>");
		$fn = $fnshort = trim($fn);
		$fn = TESTSAMPLE_PATH . "/" . $fn;
		$fp = fopen($fn, "r");
		if(!$fp) testerror("Could not open sample file '$fn'.");
		else
		{
			$tx = fread($fp, filesize($fn));
			$tx = removetags($tx);
			fclose($fp);
			if(!$tx) testerror("Nothing to analyze in sample file '$fn'.", "After removing tags the file is empty.");
			else
			{
				$tx = str_replace("\r\n", "\n", $tx);
				$tx = str_replace("\r", "\n", $tx);		
	
	//			echo("<p class=tests>Test '$pattern' on $fn:<br>");
				echo("<p class=tests>Test on $fnshort:<br>");
				if(!preg_match_all(masterPattern($pattern), $tx, $matches, PREG_SET_ORDER))
					echo("No match.<br>");
				else
					foreach($matches as $m)
					{
						echo($m[1] . " found in '" . $m[0] . "'<br>");
						$anysuccess = true;
					}
			}
		}
		echo("</p>");
	}
	if(!$anysuccess) testerror("No matches for scan pattern $scannerid $patternid in sample file(s) $samplefiles.", "", AS_PARAGRAPH);
}

function testerror($tx=null, $hint="", $ownparagraph=false)
// Double display errors: in sheet top and inline. Counts errors.
// w/o param: return errorcount.
{
	static $errors = 0;
	static $ok = false;

	if($tx === null) return errors;
	
	if($tx === "verdict")
		if($ok = !$errors)
		{
			$tx   = "Definitions checked ok.";
			$hint =	"Patterns have been checked for functionality "
			   ."against given samples. For details, check this log.";
		}
		else
		{
			$tx   = $errors . " errors.";
			$hint = "For details, check this log.";
		}
		
	// Count errors
	if(!$ok) $errors++;
	
	// Print error in log
	if($ownparagraph) echo("<p class=tests>");
	echo("<span class=" .($ok ? "ok" : "error" ). ">$tx</span><br>$hint");
	if($ownparagraph) echo("</p>");

	// Print error in log head
	errorsheet($tx, $hint, $ok);
	
}

function visibilitycontrol($cmd, $groupOrId=null)
{
	static $id = array();

	if($cmd == "writescript")
	{
	?>
	<script>
	vgroup = Array();
	<? foreach($id as $key => $count) echo "vgroup['".$key."'] = $count;\n" ?>
	function showtags(group)
	{
		id = 0;
		while(id < 200 && (x = document.getElementById(group + id)))
			writeln("would " + group + id + "<br>");
	}
	
	function showtag(id)
	{
		x = document.getElementById(id);
		x.style.display = "block";
	}

	function toggletag(id)
	{
		x = document.getElementById(id);
		if(x.style.display == "block")
			x.style.display = "none";
		else
			x.style.display = "block";
	}
	</script>
	<?
	}
	else if($cmd == "singletogglecall")
	{
		return ("<a href=# onClick='toggletag(\"$groupOrId\");'>show</a>");
	}
	else if($cmd == "getid")
	{
		$group = $groupOrId;
		if(!isset($id[$group])) $id[$group] = 0;
		else $id[$group]++;
		return ($group . $id[$group]);
	}


}


function runSampleFilesForGroups($id, $samplefiles, $grepPattern, $startPattern, $endPattern, $patternid)
{
	echo("<p class=tests>Test $id group:</p>");
			
	$files = explode(",", $samplefiles);
	$anysuccess = false;
	foreach($files as $fn)
	{
		echo("<p class=tests>");
		$fn = $fnshort = trim($fn);
		$fn = TESTSAMPLE_PATH . "/" . $fn;
		$fp = fopen($fn, "r");
		if(!$fp) testerror("Could not open sample file '$fn'.");
		else
		{
			$tx = fread($fp, filesize($fn));
			$tx = removetags($tx);
			fclose($fp);
			if(!$tx) testerror("Nothing to analyze in sample file '$fn'.",
							   "After removing tags the file is empty.");
			else
			{
				$tx = str_replace("\r\n", "\n", $tx);
				$tx = str_replace("\r", "\n", $tx);		

				$start = translatePattern($startPattern);
				$end = translatePattern($endPattern);
				echo("Test on $fnshort:<br>");
				echo("translate '$startPattern' to regex '$start',<br>");
				echo("translate '$endPattern' to regex '$end'.<br>");
				if(!preg_match("/(?:$start)(.*)(?:$end)/Us", $tx, $match))
					echo("No match in this file.<br>");
				else
					if(!isset($match[1]))
						testerror("Could not take snippet.");
					else
					{
						$visid = visibilitycontrol("getid", "logsnippet");
						echo("Found snippet: "
							. visibilitycontrol("singletogglecall", $visid)
							."<br>"
							. "<div class=logdatasnippet id="
							. $visid
							." style='display:none'>"
							. nl2br($match[1])
							. "</div>");
						$anysuccess = true;
					}
			
/*
			echo("<p class=tests>Test '$pattern' on $fn:<br>");
//			echo("<p class=tests>Test on $fnshort:<br>");
			if(!preg_match_all(masterPattern($pattern), $tx, $matches, PREG_SET_ORDER))
				echo("<span class=error>No match</span>.");
			else
				foreach($matches as $m)
						echo($m[1] . " found in '" . $m[0] . "'<br>");
*/	
			}
		}
		echo("</p>");
	}
	if(!$anysuccess) testerror("No matches for scan group $id $patternid in sample file $fn", "", AS_PARAGRAPH);
}

function runSample($patternid, $photonPattern, $sample)
{
	$pattern = translatePattern($photonPattern, "TAG"); 
	// sic TAG literal for samples.

			echo("<p class=tests>Test $patternid pattern:<br>$photonPattern translates to regex $pattern:<br>tested on sample '$sample':<br>");
			if(!preg_match_all(masterPattern($pattern), $sample, $matches, PREG_SET_ORDER))
				testerror("No match.");
			else
				foreach($matches as $m)
					if(!isset($m[1]))
						testerror("Could not take value.",
								  "Make sure to enclose the value to be "
								 ."grepped in brackets, as in '(%d) TAG'.");
					else
						echo($m[1]." found in '".$m[0]."'</p>");
}

function printtable($array, $class="")
// prints array with keys and values in a two column table.
{
	if(!$array) $array = array("-" => ""); // for consistent output formatting.
			
	echo "\n<table class=$class>\n";
	foreach($array as $key => $value)
		echo "<tr><td>$key</td><td>$value</td></tr>\n";	

	echo "</table>\n\n";
}


function messageplaceholder($initext)
// Print message place holder on top
{
	?>
	<span id=errortop><? echo $initext; ?></span>
	
	<script>
	errortopfield = document.getElementById('errortop');
	errortopfieldused = 0;
	function writeerrortop(tx)
	{
		errortopfield.innerHTML =
			(errortopfieldused++ ? errortopfield.innerHTML + '<br>' : "")
			+ tx;
	}
	// debug writeerrortop('Test');
	
	</script><?

}

function errorsheet($tx, $hint="", $ok=false)
// Print error to top of the sheet
{
	$class = $ok ? "ok" : "error";
	?>
	<script>
	writeerrortop('<span class=<? echo $class ?>><? echo $tx ?></span>');
	<? if($hint) ?> writeerrortop('<span><? echo $hint ?></span>');
	</script>
	<?
}
