<?
/*	Photon
	lib.php

	Main function library
	
	(c) 2005 Red Quant Corporation
	Licensed under the Open Software License version 2.1 
	See file LICENSE in the root folder of this distribution
	
*/

$busytime = time();

$SERVER = null;
$OPERATOR = null;
$CLIENT = null;
$USER = null;

include_once("globals.php");   // separated for scripts that don't
							   // need this full lib.
							   // pre-included by menu.php for case
							   // of incomplete setup.

include("lib-tests.php"); 	   // primarily tests the grid creation.

define('BUSY_SNAP', "logs/busysnap.html"); // hardcoded in tests.php
define('BUSY_SNAP_STYLE', "../style.css");

// Readability
define('MAIL_IT',	 	  true ); // busylog
define('WRITE_IT',	 	  true ); // busylogdump
define('DONT_ECHO',		  false); // "
define('VERBOSE',		  true ); // buildsourcegrid
define('NON_VERBOSE', 	  false); // "
define('DO_TESTS',	 	  true ); // "
define('NO_TESTS',	 	  false); // "
define('NOT_CACHED', 	  false); // cacheread
define('WITH_TIMEOUT', 	  false); // cacheread
define('NO_TIMEOUT',	  true ); // cacheread
define('TO_MEMORY_ONLY',  true ); // cachewrite
define('NO_UNIQUER',      null ); // cachewrite
define('FILE_AND_MEMORY', false); // cachewrite
define('CROSS_CLIENT',    true ); // cachewrite
define('APPEND',		  true ); // dumpbusysnap
define('CRY_WOLF',		  true ); // getsourceurl
define('REDFLASH',		  1	   ); // sendtostatusbar (disfunct)
define('BLUEFLASH',		  2	   ); // sendtostatusbar (disfunct)
define('DONT_CHECKRANGE', false); // getsourceurl
define('GET_ERROR',		  null ); // grepSE
define('NO_FINDS', 		  false); // grepSE

define('TESTSAMPLE_PATH', "testsamples");

function errorHandler($errno, $errmsg, $filename, $linenum, $vars)
{
	if(error_reporting() === 0) return; // @'d functions

	$scriptname = basename($filename, ".php");
	
	echo "
		<div style='border: 1px solid gold; background-color: black; font-size:12; font-family: Verdana, Helvetica, Arial; margin: 20; padding: 0;'>
		<div style='background-color:gold; color: brown; font-weight: bold; margin: 0; padding: 3;'>
		System Error
		</div>

		<div style='margin: 20; padding: 20;'>
		<div style='color:gold; font-weight:bold;'>

		Please notify photon.support@authinc.com or call 404 806 7125.
		
		</div>";

	echo "
		<div style='color:silver; font-weight:normal; font-size:9px;'>

		<br>Error $scriptname ".VERSION." $linenum: $errmsg ($errno)
		<br>
		</div>";
	
	echo "</div></div>";	

	$dump = ""; foreach($vars as $k => $v) $dump .= "$k=$v;";
	phone(4, "Error $scriptname ".VERSION." $linenum: $errmsg ($errno)",
		"$filename ".VERSION." $linenum - $dump");
	
	exit();
}

function xassert($ok, $msg, $detail="")
{
	if($ok) return;
	
	// nice bolds
	$msg = preg_replace("/\*(.*)\*/U", "<i>\\1</i>", $msg);

	echo "
		<div style='border: 1px solid silver; background-color: black; font-size:12; font-family: Verdana, Helvetica, Arial; margin: 20; padding: 0;'>
		<div style='background-color:silver; color: dimgray; font-weight: bold; margin: 0; padding: 3;'>
		Setup Issue
		</div>

		<div style='margin: 20; padding: 20;'>
		<div style='color:silver; font-weight:bold;'>
		
		Please notify your system operator.
		
		</div>";

	echo "
		<div style='color:silver; font-weight:normal; font-size:9px;'>
		<br>$msg
		<br>$detail
		</div>";
	
	echo "</div></div>";
	
	exit();
}

$old_error_handler = set_error_handler ("errorHandler" ); 

include("support.php"); // separated for tests.php

$monthnames = array("Januar", "Februar", "Mrz", "April", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember");

$server = $_SERVER['SERVER_NAME'];
$server = str_replace("www.", "", $server);

$users = array();
$user = isset($_SERVER['REMOTE_USER']) ? $_SERVER['REMOTE_USER'] : null;

if(!$user)
$user = "installer";
// e.g. menu.php dies at this point when authentication is off.

$serverifn = serverinifilename();

if(!file_exists($serverifn)) 
{
	$serverifn = serverinifilename("generic");
		if(!file_exists($serverifn)) die("Server ini file <b>$serverifn</b> missing.");
}

$serverinis = parse_ini_file($serverifn, true); 
foreach($serverinis as $sectionname => $c)
{
		if(strstr($sectionname, "USERS ") !== false)
		{
			$clientname = trim(str_replace("USERS ", "", $sectionname));
			$clientname = strtolower($clientname);
	
			foreach($c as $userid => $level)
			{
				$users[$userid]['client'] = $clientname; 
				$users[$userid]['level'] = $level; 
			}	
		}
} 
// print_r($users);
	

if(!isset($users[$user])) die("Unknown user <b>$user</b>. Please contact your support assistant to add user '$user' to server ini file in appropriate client section.<br><br>To change users, or logout, quit the browser (Mac), and/or close all browser windows (Linux/Win).");
// $user from authentication.

$USER = $user;
$USERLEVEL = $users[$user]['level'];
$CLIENT = $client = $users[$user]['client'];

if($user == "installer" || $client == "generic")
{
	$clientifn = "[no client ini file for installer]";
	$inis = array();
}
else
{
	$clientifn = clientinifilename($client);
	if(!file_exists($clientifn)) { echo("Client ini file <b>$clientifn</b> for client <b>$client</b> missing."); exit(); }

	$inis = parse_ini_file($clientifn, true); 
}

$clientinis =& $inis;
// true =: with sections
// $inis = $clientinis, simply synonyms
$sourcegrid = null;
$scangrid = null;
$evalgrid = null;
$small_memorycache = array();
$big_memorycache = array();

// Re-store and check range, possibly set default, for defs from ini file.(*1*)
pulldefinition('BIG_SMALL_THRESHOLD', "server ini file", $serverifn,
	$serverinis, 'CACHE', 'big_small_threshold', 10, null, 100);
pulldefinition('BIG_MEMORY_CACHE_SIZE', "server ini file", $serverifn, 
	$serverinis, 'CACHE', 'big_memory_cache_size', 0, null, 15);
pulldefinition('SMALL_MEMORY_CACHE_SIZE', "server ini file", $serverifn, 
	$serverinis, 'CACHE', 'small_memory_cache_size', 0, null, 1000);
pulldefinition('CACHE_WRITE_DISABLED', "server ini file", $serverifn, 
	$serverinis, 'CACHE', 'write_disabled',  null, null, false);
pulldefinition('BUSYLOG_CACHE', "server ini file", $serverifn, 
	$serverinis, 'CACHE', 'busylog',  null, null, true);
pulldefinition('CACHE_ALLOWED_AGE', "server ini file", $serverifn, 
	$serverinis, 'CACHE', 'allowed_age',  0, null, 3600);

// Search Engine
pulldefinition('SEARCH_ENGINE_NAME', "server ini file", $serverifn, 
	$serverinis, 'SEARCH ENGINE', 'name',  null, null, "");
pulldefinition('SEARCH_ENGINE_IMAGE', "server ini file", $serverifn, 
	$serverinis, 'SEARCH ENGINE', 'image',  null, null, "");
pulldefinition('SEARCH_ENGINE_QUERY', "server ini file", $serverifn, 
	$serverinis, 'SEARCH ENGINE', 'query',  null, null, "");
pulldefinition('SEARCH_ENGINE_URL_SCAN_PATTERN', "server ini file", $serverifn, 
	$serverinis, 'SEARCH ENGINE', 'url_scan_pattern',  null, null, "");
pulldefinition('SEARCH_ENGINE_SEARCH_TERM', "client ini file", $clientifn, 
	$clientinis, 'SEARCH ENGINE', 'search_term',  null, null, $client);

// Logs
pulldefinition('ERROR_MAIL', "server ini file", $serverifn, 
	$serverinis, 'LOGS', 'error_mail',  null, null,
	"none");
pulldefinition('PHONE_HOME', "server ini file", $serverifn, 
	$serverinis, 'LOGS', 'phone_home',  null, null, true);
pulldefinition('PHONE_ENCRYPTION', "server ini file", $serverifn, 
	$serverinis, 'LOGS', 'phone_encryption',  null, null, false);
pulldefinition('PHONE_ANONYMIZATION', "server ini file", $serverifn, 
	$serverinis, 'LOGS', 'phone_anonymization',  null, null, true);
pulldefinition('PHONE_LEVEL', "server ini file", $serverifn, 
	$serverinis, 'LOGS', 'phone_level',  null, null, 3);

// Language
pulldefinition('LANGUAGE', "client ini file", $clientifn, 
	$clientinis, 'CLIENT', 'language',  null, null, "english");
pulldefinition('APPEND_MISSING_LANGUAGE_ENTRIES', "server ini file", $serverifn, 
	$serverinis, 'LANGUAGE', 'append_missing',  null, null, false);


$notes = "";

$busylog = PROGRAM . " " . VERSION . " Run " . date("Y m d H:i:s") . " by " . $user . " at " . $_SERVER["SERVER_NAME"] . "\r\n---\r\n";


// ***************************************************************************
// ***************************************************************************
// CACHE FUNCTIONS
// ***************************************************************************
// ***************************************************************************

function cachedaccess($source, $tag, $checktagrange=true)
// Local file & memory cache.
// Local file cache hands on from one php invocation to the next.
// Memory cache for the invocation itself.
{

	$url = getsourceurl($source, $tag, $checktagrange, CRY_WOLF);
	if(!$url) return null;
	
	$hurl = hidepw($url);
	busylog("Getting '$hurl'", 1);
	
	// Try cache (file and memory)
	$src = cacheread("strippedsource", $source, $tag, $fn);
	
	if($src === NOT_CACHED) 
	{ 
		$src = removetags(@file_get_contents($url));
		if($src)
		{
			// Remote loading
			busylog("Retrieved remotely: $source $tag");
			
			// Save to cache (file and memory).
			cachewrite("strippedsource", $source, $tag, $src);
		}
		else
		{
			// Failed remote access:
			// Try file cache again, now ignoring expiration
			busylog("Remote access failed: $source $tag");
			$src = cacheread("strippedsource", $source, $tag, $fn, NO_TIMEOUT);
			if($src !== NOT_CACHED) 
				busylog("Retrieved EXPIRED from file cache $source $tag $fn");
			else
				busylog("FAILED REMOTE ACCESS $source $tag.", 0, MAIL_IT);
		}
	}
	busylog("", -1);

	return $src;
}

function cachewrite($type, $source, $tag, $src, $uniquer="", $writetomemoryonly=false, $crossclient=false)
// Write a value or text to file and memory cache.
// Don't write bools!
// big and small memory cache is used for big data such as scanner source files
// (whole Webalyzer etc reports) and small ones like values. This, to allow
// different numbers of entries in the cache, before oldest are discarded.
// Simple first used first out cache management.
{
	global $small_memorycache;
	global $big_memorycache;

	if(CACHE_WRITE_DISABLED)
	{	
		busylog("Cache write disabled.");
		return;
	}
	
	$fn = cachename($type, $source, $tag, $uniquer, $crossclient);

	// Save to file.
	if(!$writetomemoryonly) // skip when called by cacheread 
	{						// that just pulled from file cache
		$fp = fopen($fn, "w");
		fwrite($fp, $src);
		fclose($fp);
	}
	
	// Save to memory cache.

	// Decide for what cache to use.
	if(strlen($src) >= BIG_SMALL_THRESHOLD)
	{
		$name = "big memory cache";
		$size = BIG_MEMORY_CACHE_SIZE;
		$memorycache =& $big_memorycache;
	}
	else
	{
		$name = "small memory cache";
		$size = SMALL_MEMORY_CACHE_SIZE;
		$memorycache =& $small_memorycache;
	}
	if(BUSYLOG_CACHE) busylog("Using $name.");

	if(!isset($memorycache[$fn]))
	{
		if(BUSYLOG_CACHE) busylog("$name size now " . count($memorycache));

		// control memory usage. First in, first out when cache size exceeded.
		if(count($memorycache) > $size)
		{
			reset($memorycache); // reset := cursor to top
			$k = key($memorycache);
			$v = current($memorycache);
			
			if(BUSYLOG_CACHE) busylog("Throwing oldest $name entry out: $k: '".substr($v,0,10). (strlen($v)>10?"...":"")."'");
			
			array_shift($memorycache);
		}
		
		// save
		$memorycache[$fn] = $src;
		
		if(BUSYLOG_CACHE) busylog("$name size now " . count($memorycache));
	}
}

function cacheread($type, $source, $tag, &$cachename, $notimeout=false, $uniquer="", $crossclient=false)
// Get a value or text from memory or local file cache
// Returns false when no cached value exists or time out. 
{
	global $small_memorycache;
	global $big_memorycache;

	$fn = $cachename = cachename($type, $source, $tag, $uniquer, $crossclient);
		
	// Try memory cache
	$value = isset($memorycache[$fn]) ? $memorycache[$fn] : NOT_CACHED;

	if($value !== NOT_CACHED)
	{
		busylog("Hit in memory cache: $type $source $tag");
		return $value;
	}

	// Try file cache
	if(!file_exists($fn)) 
	{
		xlog("$type $source $tag: $fn not found in file cache");
		return NOT_CACHED;
	}
	// Expired? (Can be overriden by $notimeout).
	if(ispast($tag))
		busylog("Using permanent cache for past time data.");
	
	else if($notimeout)
		busylog("Ignore cache expiration.");
	
	else if(filemtime($fn) < time() - CACHE_ALLOWED_AGE)
	{
		xlog("$type $source $tag: $fn expired in file cache (TTL " . CACHE_ALLOWED_AGE . " sec)");
		return NOT_CACHED;
	}
		
	// Now read cached value
	$fp = fopen($fn, "r");
		$value = fread($fp, filesize($fn)); 
	 // $value = fread($fp, filesize($fn)); // FILE_BUFFER_SIZE);
	fclose($fp);
	
	busylog("Hit in file cache: $type $source $tag");
	
	// Save to memory cache
	cachewrite($type, $source, $tag, $value, $uniquer, TO_MEMORY_ONLY);

	return $value;
}


function xlog($text)
// MUST return false or messes up functionality.
{
	return false;
	echo(": $text <br>");
	return false;
}

// ***************************************************************************
// ***************************************************************************
// TIME TAG FUNCTIONS
// ***************************************************************************
// ***************************************************************************

// makemonth(time());
// Test $urls = getsourceurls("200508");
// ... scancell("Total Hits", $urls);

function makemonthtag($time)
// Create a tag yyyymm to identify months in a simple sortable way
// '200510' for Oct 05
// That's from Webalyzer but used throughout
{
	$date = getdate($time);
	$month = $date["mon"];
	$year = $date["year"];
	return ($year . $month);
}

function makemonth($time)
{
	global $monthnames;

	$now = getdate($time);
	$nowmonth = $now["mon"];
	$nowyear = $now["year"];
	return ($nowyear . $nowmonth);
}

function getvalidindexes($tag, $scanner = null, $alternate = false)
// return array of indexes to urls that are to be used for the tag-time.
// (The summing up happens sort of 'inbetween' to use the cashes best.)
// scanner and alternate is to allow PRESETS to force an
// alternate choice of scanners as e.g. the referrer evaluation.
{
	global $sourcegrid;
	if($sourcegrid === null) buildsourcegrid();
	
	$is = array(); // $is becomes list of valid sourcegrid indexes for that tag
	
	foreach($sourcegrid as $i => $a)
	{
		if($scanner === null || $scanner == $a['scanner'])
		{	
			// Mess with alternate starts and endings.
			$start = isset($a['start']) ? $a['start'] : 0;
			$end   = isset($a['end']) ? $a['end'] : "*";
			if($alternate && isset($a['alternate_start']))
				$start = $a['alternate_start'];
			if($alternate && isset($a['alternate_end']))
				$end = $a['alternate_end'];
			
			//	debug echo("<br> $i $start $end");
			
			// Check out now and remember
			if($start <= $tag && ($end >= $tag || $end == "*"))
				$is[] = $i;
		}
	}
	
	
	if(!count($is)) busylog("No sources in time range.");
	return $is;
}

function ispast($tag)
// determine if a tag is of a month in the past so it's values can be taken from the caches.
{
	// static for speed.
	static $thismonthstag = null;
	if(!$thismonthstag) $thismonthstag = makemonth(time());
	
	return ($tag < $thismonthstag) && strlen($tag == 6);
}


function getsourceurls($tag)
// return array of urls to scan and join for a statistics value.
{
	global $sourcegrid;
	$urls = array();
	
	foreach($sourcegrid as $a)
	{
		if($a['start'] <= $tag && $a['end'] >= $tag)
		{
			$urls[] = sprintfsourceurl($a['url'], $tag);
		}
	}

	return $urls;
}

function getsourceurl($i, $tag, $checkrange = true, $cry_wolf=false)
// return one url prepared from the sourcegrid to scan for a statistics value.
// return false if outside min max time range
// return null for invalid index
{
	global $sourcegrid;
	
	// Not a valid index
	if(!isset($sourcegrid[$i]))
	{	
		if($cry_wolf)
			busylog("INVALID SCANNER ID '$i' in url lookup $i $tag.",-1, MAIL_IT);
		return null;	
	}

	$a = $sourcegrid[$i];

	if(!$checkrange || ($a['start'] <= $tag && $a['end'] >= $tag))
		
		// ok
		return sprintfsourceurl($a['url'], $tag);

	else	
	{	// Outside time range.
		if($cry_wolf)
			busylog("TIME RANGE VIOLATION in url lookup $i $tag.",-1, MAIL_IT);
		return false;	
	}
}

function getsourcename($i)
// return one name of source from the sourcegrid for logging, error messages.
{
	global $sourcegrid;

	// Not a valid index
	if(!isset($sourcegrid[$i])) return "undefined data source (index $i)";

	$a = $sourcegrid[$i];
	
	if(!isset($a['name'])) return "data source #$i";

	return $a['name'];
}

function scancell($prompt, $urls)
{
	foreach($urls as $url)
	{
		echo("Scanning $url<br>");
		$src = file_get_contents($url);
		$stripped = removetags($src);
		if(preg_match("/$prompt\s*\w+/i", $stripped, $match))
			echo(htmlentities($match[0]) . "<br>");
	}
}

function removetags($src, $careful=true)
// remove the HTML but leace *contents* of tags there.
// with carefull: check if it had been done before and don't redo.
// This automatism gives some flexibility with sample files.
{
	// Don't do if there are no tags anyway (anymore).
	if($careful)
		if(!preg_match("/<.+>/U", $src))
			return $src;

	$src = preg_replace("/\n|\r/", " ", $src);
	$src = preg_replace("/<\/tr>/Ui", "\n", $src);
	$src = preg_replace("/<br ? \/?".">/Ui", "\n", $src);
	$src = preg_replace("/<p ? \/?".">/Ui", "\n", $src);
//	$src = preg_replace("/<\w*\/p>/Ui", "\n", $src);
	$src = preg_replace("/<.+>/U", " ", $src); // could be done better
	// echo(nl2br($src));
	return $src;
}

// ***************************************************************************
// ***************************************************************************
// DATA FUNCTIONS
// ***************************************************************************
// ***************************************************************************

function display($i, $tag, $var)
// Just show the stripped retrieved page
{
	if($var === null)
	{
		$src = cachedaccess($i, $tag);
		if($src)
			echo(nl2br($src));
		else
			echo "Failed to access $i $tag";
		
	}
	else
		echo("* $var: " . getScalar($i, $tag, $var));

}

function getScalar($source, $tag, $pattern, $identifier="", $clearName = "")
// Get a scalar value scanned from a source.
// Also a summing up: namely of all matches for the pattern inside one source.
{
/*
	global $sourcegrid;
	global $scangrid;

	$scanner = $sourcegrid[$source]['scanner'];
	echo($scanner);
	$type = "simple";
	$pattern = $scangrid[$scanner][$type];
	echo($pattern);
*/	

	// Check cache
	if($identifier)
		// must have unique id with it. Can be omitted in signature
		$value = cacheread("scalar." . $identifier, $source,
						$tag, $cachename);
	else
		$value = NOT_CACHED;
	
	if($value !== NOT_CACHED) 
	{
		busylog("Found in cache: $value");
		return $value; 
	}
	$pattern = (strpos($pattern, "\\") === false) ?
		"$pattern\s*([\w\d]+)" : $pattern;

	$pattern = str_replace(" ", "\s+", $pattern);
	$pattern = str_replace("%d", "(\d+)", $pattern);
	$pattern = str_replace("%a", "([\w\d.,_'/-]+)", $pattern);
	$pattern = str_replace("%l", "([^\n]+)", $pattern);
	$pattern = str_replace("%s", "([^.]+)", $pattern);
	$pattern = str_replace("%p", "([\d.,-]+)\s*%", $pattern);
	
	$clearName = $clearName ? $clearName : "$source $tag $pattern";
	
	busylog("Get Scalar $source ($clearName)", 1);
	busylog("Scanpattern '$pattern' created from '$pattern'");

	$src = cachedaccess($source, $tag, 
		DONT_CHECKRANGE); // don't as it doesn't regard alternates.
	$value = 0;
	if($src)
	{
		if(preg_match_all("/$pattern/i", $src, $match))
			foreach($match[1] as $m)
			{
				$value += $m;
				busylog("Found: $m");
			}
		else
			$value = null;
	
		busylog("Found sum: " .(($value!== null) ? $value : "0 (no finds)"));

		// Write cache
		cachewrite("scalar." . $identifier, $source, $tag, 
			$value);

	}
	else
	{
		busylog("Missed out on lacking source.");
		note("Not included: $clearName");
	}
		
	busylog("", -1);
	return $value;
}

function getSummedScalar($tag, $pattern, $identifier="", $clearName="", $forcescanner=null, $alternate=false)
// Get a value, summed up accross multiple sources.
// Bit weired, here is where it's found out on the way, what $source are valid for this timetag. 
{
	$alternate = ($alternate === "yes" || $alternate === true); // for safety

	// debug echo("<br> $forcescanner $alternate");
	$sources = getvalidindexes($tag, $forcescanner, $alternate);
	$sum = 0;

	$clearName = $clearName ? $clearName : "$tag $pattern";

	busylog("Summing up $tag ($clearName):", 1);
	foreach($sources as $source)
	{
		$sum += getScalar($source, $tag, $pattern, $identifier, 
		$clearName . " from " . getsourcename($source));
	}
	busylog("Sum: $sum", -1);

	return $sum;
}

	
function getSummedReferrers(&$refcompendium, $tag, $verbose=false)
// Get a value, summed up accross multiple sources.
// Here is where it's found out "on the way", what $source are valid for this timetag. 
{
	
	$sum = 0;

	$clearName = "Referrer List $tag";

	busylog("Summing through $tag ($clearName):", 1);

	if($verbose) startsheet();


	if($verbose) visibilitycontrol("writescript"); // flag to write java script

	scanGroup($refcompendium, "referrer", $tag, $verbose);

	if($verbose) endsheet();

	busylog("Done summing through $tag ($clearName):", -1);

	return $sum;
}

function scanGroup(&$refcompendium, $patternid, $tag, $verbose=false)
{
	global $sourcegrid;
	global $scangrid;
	global $clientifn;
	global $serverifn;

	
	if($verbose) echo("<p class=tests>Scan $patternid $tag group:</p>");
			
	$sources = getvalidindexes($tag);
	
	if(!$sources) 
	{
		if($verbose) echo("<p class=tests>No sources in time range '$tag' for $patternid $tag group.</p>");
	
		return;
	}
	
	$anysuccess = false;
	foreach($sources as $source)
	{
	
		if($verbose) echo("<p class=tests>");
		
		xassert(isset($sourcegrid[$source]['scanner']),
		"Source definition for *$source* missing *scanner* value " .
		"in $clientifn.");
	    $scanner = $sourcegrid[$source]['scanner'];

		xassert(isset($scangrid[$scanner]),
		"Scanner definition for *$scanner* missing " .
		"in $serverifn, used by source definition *$source* in $clientifn.");
		xassert(isset($scangrid[$scanner][$patternid]),
		"Scanner definition for *$scanner* missing *$patternid* value " .
		"in $serverifn.");
		xassert(isset($scangrid[$scanner][$patternid . "Start"]),
		"Scanner definition for *$scanner* missing *{$patternid}Start* value ".
		"in $serverifn.");
		xassert(isset($scangrid[$scanner][$patternid . "End"]),
		"Scanner definition for *$scanner* missing *{$patternid}End* value " .
		"in $serverifn.");
		$pattern = $scangrid[$scanner][$patternid];
		$startPattern = $scangrid[$scanner][$patternid . "Start"];
		$endPattern   =	$scangrid[$scanner][$patternid . "End"];

		$src = cachedaccess($source, $tag);
		if(!$src)
		{
			if($verbose) echo("No source for $source $tag");
		}
		else
		{
			$src = str_replace("\r\n", "\n", $src);
			$src = str_replace("\r", "\n", $src);		

			$regex = translatePattern($pattern);
			$start = translatePattern($startPattern);
			$end = translatePattern($endPattern);
			if($verbose) echo("$scanner scan on $source $tag:<br>");
			if($verbose) echo("translate '$pattern' to regex '$regex',<br>");
			if($verbose) echo("translate '$startPattern' to regex '$start',<br>");
			if($verbose) echo("translate '$endPattern' to regex '$end'.<br>");
			if(!preg_match("/(?:$start)(.*)(?:$end)/Us", $src, $match))
			{
				if($verbose) echo("No match in this file.<br>");
			}
			else
			{
				$src = $match[1];	
				
				if($verbose) $visid = visibilitycontrol("getid", "logsnippet");
				if($verbose) 
					echo("Found entries: "
						. visibilitycontrol("singletogglecall", $visid)
						. "<br>"
						. "<div class=logdatasnippet id="
						. $visid
						. " style='display:none'>"
						// . nl2br($src)
						);
						
				$anysuccess = true;
			
				$lines = explode("\n", $src);
			
				$subdomains = "www|home|de|search|sucheaol|sea\.search|images|neu|suche|vachercher|aolsearch|us\.f\d+\.mail".
					"|cgi\d*" .			// cgi3.ebay
					"|\w\w\.search" . 	// br.search.yahoo
					"|\w\d\d\d?" .		// f256.mail.yahoo, m02.webmail.aol
					"|\w\w\.\w\d\d\d" . // it.f516.mail.yahoo
					"|\d+" .			// 16272.rapidforum
					"|mail\d+" .		// mail01.mail
					"|mymail\d+" .		// mymail01.mail.lycos
					"|.+\.(?=hotmail)" . // by104fd.bay104.hotmail.Msn
					"";
				$topdomains = "de|com|org|net|info|co\.uk|at|ch|nl|ae|be|ca|cl|dk|es|fi|fr|lt|it|lv|no|pl|ro|ru|se|sk|co\.|co\.cr|co\.il|co\.hu|co\.th|co\.za|co\.in|co\.jp|co\.kr|co\.nz|co\.ve|com\.ar|com\.au|com\.br|com\.fj|com\.gr|com\.gt|com\.hk|com\.mx|com\.my|com\.pe|com\.ph|com\.pr|com\.sa|com\.sg|com\.tr|com\.tw|com\.vn";

				foreach($lines as $line)
				{
					sendtostatusbar("$source $tag :: Analyzing: $line");
					$failedresolve = false;
				
					if(preg_match("!http://(www\.)?stage-?school\.de!", $line))						
						;
					else if(!trim($line))
						;
					else
					{
						// Take value
						if(preg_match("/$regex/", $line, $match))
							$value = $match[1];
						else
							$value = null;

						// Take Host URL
						if(preg_match("!http://(\S+?)/!", $line, $match))
							$host = $match[1];
						else
							$host = null;
							
						// Take URL
						if(preg_match("!http://(\S+)!", $line, $match))
							$url = $match[0];
						else
							$url = null;
							
						// IP# ?
						if(preg_match("!http://(\d+\.\d+\.\d+\.\d+)/!", $line, $match))
						{	
							$ip = $match[1];

							// Try cache first. Saves tons of time.
							$result = 
								cacheread("iplookup", "", $ip, $fn,
								NO_TIMEOUT, NO_UNIQUER, CROSS_CLIENT);
							
							if($result === NOT_CACHED)
							{
								sendtostatusbar("$source $tag: Resolving $ip", REDFLASH);
								busylog("$source $tag: Resolving $ip");

								$domainname = gethostbyaddr($ip);
							
								if($domainname == $ip) // so, didn't work.
									if($url)
									{
										sendtostatusbar("$source $tag: trying to read title of $url", REDFLASH);
										busylog("$source $tag: trying to read title of $url");
										$result = getTitle($url);
									}
				
								// write cache
								// if($result)
								{
									busylog("Write looked up IP $ip: $result to cache.");
									cachewrite("iplookup", "", $ip,
									$result ? $result : $ip, NO_UNIQUER,
									FILE_AND_MEMORY, CROSS_CLIENT);
								}
								if(!$result)
								{
									busylog("Failed to resolve IP $ip in $url");
									$failedresolve = true;
								}
							}
							if(!$result) $result = $ip;
						}
						// Normal case: scan out name part of url
						else if(preg_match("!http://(?:(?:$subdomains)\.)*(.*?)(?:\.(?:$topdomains))?(?:/|\))!i", $line, $match))
						{
							$result = $match[1];
						}
						else
						{
							$result = "no match";
						}
						
						// $refid = strtolower($result);
						$refid = 
						$hresult  = prettycaps($result);
						$xpattern = prettypattern($hresult);
						
						// $refid Uppercase and w/o .-_ chars
						// to be compatible with possible
						// $result from getTitle.
						// e.g. Young Magazin got from
						// title matches young-magazin from url.
						// All else risks having two identical
						// entries displayed in the Menu,
						// as they are displayed pretty printed.
						// Like: 2 entries for Young Magazin,
						// one from title Young Magazin ->
						// id 'young magazin' and one from url ->
						// id 'young-magazin'.
					
						// $xpattern to re-recognize this url. 
						// Not used as of 0.9.98
					
						if($verbose) echo("$line: $hresult - $value<br>");
			
						sendtostatusbar("$source $tag :: $line: $hresult - $value");

						// IP could be read from cache, stored instead
						// of clearname when earlier resolve failed.
						if(preg_match("!http://(\d+\.\d+\.\d+\.\d+)/!", $line, $match))
							$failedresolve = true;

						if(!$failedresolve
							&& $result != "no match"
							)
						{
	
							if(isset($refcompendium[$refid]))
								;
							else
							{
								$refcompendium[$refid] = array();
								$refcompendium[$refid]['name'] = $hresult; 
								// effectively == $refid
							}
								
							if(isset($refcompendium[$refid]['hosts']
									[$host]['sum']))
								$refcompendium[$refid]['hosts']
									[$host]['sum'] += $value;
							else
								$refcompendium[$refid]['hosts']
									[$host]['sum'] = $value;
	
							if(isset($refcompendium[$refid]['urls']
									[$url]['sum']))
								$refcompendium[$refid]['urls']
									[$url]['sum'] += $value;
							else
								$refcompendium[$refid]['urls']
									[$url]['sum'] = $value;
	
							// Month sum per URL
							if(isset($refcompendium[$refid]['urls']
									[$url][$tag]))
								$refcompendium[$refid]['urls']
									[$url][$tag] += $value;
							else
								$refcompendium[$refid]['urls']
									[$url][$tag] = $value;
	
							if(isset($refcompendium[$refid]['urls']
									[$url]['met']))
								$refcompendium[$refid]['urls']
									[$url]['met'] ++;
							else
								$refcompendium[$refid]['urls']
									[$url]['met'] = 1;
	
							if(isset($refcompendium[$refid]['urls']
									[$url]['pattern']))
								$refcompendium[$refid]['urls']
									[$url]['pattern'] = $xpattern;
									// SHOULD be the same per url but
									// pattern could be met more than
									// once across multiple URLs.
									// This makes re-recognizing urls
									// per pattern the WRONG approach
									// unless patterns are ored in one 
									// preg match. But DON'T iterate
									// preg matchings.
	
	
							if(isset($refcompendium[$refid]['sum']))
								$refcompendium[$refid]['sum'] += $value;
							else
								$refcompendium[$refid]['sum'] = $value;
	
							if(isset($refcompendium[$refid][$tag]))
								$refcompendium[$refid][$tag] += $value;
							else
								$refcompendium[$refid][$tag] = $value;
	
						}
					
					}	
				}
					
				if($verbose) echo("</div>");
				flush();
					
			}
		}
		if($verbose) echo("</p>");
	}
	
	if($verbose) if(!$anysuccess) echo("<p class=tests>No matches for scan group $patternid $tag</p>");

	dumpbusysnap("Referrer List", DONT_ECHO, WRITE_IT);
}

function buildrefcompendium(&$refcompendium, $verbose=false)
{
	if($verbose)
		echo '<link rel="stylesheet" type="text/css" href="style.css">';
	if($verbose) echo "<h1>Referrer</h1>";

	busylog("*** Retrieving data: Referrer List ***");

	// DEBUG buildsourcegrid(VERBOSE, DO_TESTS); 
	// buildsourcegrid(NON_VERBOSE, NO_TESTS); 

	$months = make12monthtags(time());
	$refcompendium = array();
	$iterations = 1;
	foreach($months[MONTH_TAGS] as $im => $month)
	{
			$clearname = "Referrer " . $months[MONTH_NAMES][$im];
			
			$gauge = str_repeat("&bull;", $iterations++);
			sendtostatusbar($gauge . " " . $clearname);

			getSummedReferrers($refcompendium, $month, $verbose);
	}

	ksort($refcompendium);

	if($verbose)
		foreach($refcompendium as $refid => $com)
		{
			echo("<b>$refid ".$com['sum']."</b><br>");
			foreach($com['urls'] as $url => $count)
				echo("<b>$count</b> $url<br>");
		}
	
	sendtostatusbar("Cache referrer.");
	writecompendium("referrer", $refcompendium, REF_COMPENDIUM_VERSION);

	sendtostatusbar("Referrer List complete.");
}

function preptrendsetc($a)
// expects data in column 1 (second 'column') $a[1].
// Header in row [i][0]
// Puts 
// a[2]		diff pre month abs
// a[3]		diff pre month %
// a[4]		avrg
// a[5]		diff avrg abs
// a[6]		diff avrg %
// a[7]		avrg trend abs (trend = diff 
// a[8]		avrg trend %
// a[9]		avrg trend %
// a[10]	avrg trend %
{
	

	$a[2][0] = "+ -";
	$a[3][0] = "%";
	$a[4][0] = I("Month/Avg");
	$a[5][0] = "%";
	$a[6][0] = I("Trend");
	$a[7][0] = "+ -";
	$a[8][0] = "%";
	$a[9][0] = I("Month/Trend");
	$a[10][0] = "%";


	// Forecast to make sense for details
	$ifc = getforecastcandidate($a[0]);
	if($ifc) $a[1][$ifc] = forecast($a[1][$ifc], $ifc);

	$data = $a[1];
	if(!$data) return null;
	$c = count($data) -1; // $c = highest index, not 1 higher than ..
	if($c < 1) return null;

	
	$max = max($data);
	$min = min($data);
	$totsum = array_sum($data); 
	$totavg = ceil($totsum / $c); 
	$totdifabs = $data[$c] - $data[1];
	$totdifprc = ($data[1] != 0) ? (($data[$c] - $data[1])*100/$data[1]) : 100;
	$totdifabsper = ceil($totdifabs / $c);
	$totdifprcper = ceil($totdifprc / $c);
	$prv = 0;
	$preprv = 0;
	$prepreprv = 0;
	$prvtrnsumavg = 0;
	for($i = 1; $i<= $c; $i++)
	{
		$v = $data[$i];
		$difpreabs = $v - $prv;
		$difpreprc = ($prv != 0) ? (($v - $prv) * 100 / $prv) : 100;
		$difavgabs = $v - $totavg;
		$difavgprc = ($totavg != 0) ? (($v - $totavg) * 100 / $totavg) : 100;
		$trnsum = $v + $prv + $preprv; // + $prepreprv;
		$trnsumavg = ceil(($trnsum) / 3); 
		$trnsumavgdifabs = $trnsumavg - $prvtrnsumavg;
		$trnsumavgdifprc = ($prvtrnsumavg != 0) ? (($trnsumavg - $prvtrnsumavg) * 100 / $prvtrnsumavg) : 100;
		$trnmntabs = $v - $trnsumavg;
		$trnmntprc = ($trnsumavg != 0) ? (($v - $trnsumavg) * 100 / $trnsumavg) : 100;
		
		$a[2][$i] = ($i == 1) ? "" : sprintf("%+d", $difpreabs);
		$a[3][$i] = ($i == 1) ? "" : sprintf("%+01.2d%%", $difpreprc);
		$a[4][$i] = sprintf("%+d", $difavgabs);
		$a[5][$i] = sprintf("%+01.2d%%", $difavgprc);
		$a[6][$i] = ($i < 3) ? "" : $trnsumavg;
		$a[7][$i] = ($i < 4) ? "" : sprintf("%+d", $trnsumavgdifabs);
		$a[8][$i] = ($i < 4) ? "" : sprintf("%+01.2d%%", $trnsumavgdifprc);
		$a[9][$i] = ($i < 4) ? "" : sprintf("%+d", $trnmntabs);
		$a[10][$i] = ($i < 4) ? "" : sprintf("%+01.2d%%", $trnmntprc);
		
		$prepreprv = $preprv;
		$preprv = $prv;
		$prv = $v;
		
		$prvtrnsumavg = $trnsumavg;
	}

	$a[0][$i] = I("Avg");
	$a[1][$i] = $totavg;
	$a[2][$i] = sprintf("%+d", $totdifabsper);
	$a[3][$i] = sprintf("%+01.2d%%", $totdifprcper);
	$a[4][$i] = ""; 
	$a[5][$i] = ""; 
	$a[6][$i] = ""; 
	$a[7][$i] = ""; 
	$a[8][$i] = ""; 
	$a[9][$i] = ""; 
	$a[10][$i] = ""; 

	
	return $a;
}


function forecast($v, $index, $verbose=false)
{
	if($verbose) echo("Forecast $v $index: ");

	$now = time();
	$d = getdate($now);
	$y = $d['year'];
	$m = $d['mon'];
	$d = $d['mday'];
	
	$start = mktime(0,0,0, $m, 1, $y);
	$end = mktime(0,0,0, $m + 1, 1, $y); 
	// sic 0 see http://www.php.net/manual/en/function.mktime.php


	if($now - $start == 0) return 0;

	$estimate = ceil(($v / ($now - $start)) * ($end - $start));	
	
	$p1 =  $now - $start;
	$p2 =  $end - $start;
	if($verbose) echo("$p1 $p2: $v $estimate ");
	return $estimate;


}

function getforecastcandidate($aTest)
// $aTest is an array of months,
// allowed are "Dec 05" (internationalized, as in the right most column)
// or a tag "200512" as array values.
// Returns INDEX of $aTest!
{
	$tagandlabel = make1monthtag(time()); // Internationalizes.

	foreach($aTest as $k => $s)
	{
	// echo("<br>$s::{$tagandlabel['MONTH_TAGS']}::{$tagandlabel['MONTH_NAMES']}");
		if($tagandlabel[MONTH_TAGS] == $s
		|| $tagandlabel[MONTH_NAMES] == $s)  return $k;
}
	return false;
}

// ***************************************************************************
// ***************************************************************************
// ERROR FUNCTIONS
// ***************************************************************************
// ***************************************************************************

function errexit($text)
{
	echo "<table width=100% height=100%><tr><td align=center>";
	echo "<a href=index.php><img src=images/photon.logo.2.1-square160.png border=0></a>";
	echo "<div class=error>" . $text . "</div>";
	echo "</td></tr></table>";
	exit();
}

function errexitgraph($text)
// Data: display error instead of chart (as a chart)
{

	$support = str_replace("\r", "\n", SUPPORT); 

	$chart [ 'chart_data' ] = 
	
 		array ( array (),
		array ()
	); 

$chart [ 'axis_value' ] = array (   'min'           =>  0,  
                                    'max'           =>  0, 
                                    'steps'         =>  0,  
                                    'prefix'        =>  "", 
                                    'suffix'        =>  "", 
                                    'decimals'      =>  0,
                                    'decimal_char'  =>  ",",
                                    'separator'     =>  ".", 
                                    'show_min'      =>  false, 
                                    'font'          =>  "Arial", 
                                    'bold'          =>  true, 
                                    'size'          =>  12, 
                                    'color'         =>  "gray", 
                                    'alpha'         =>  0,
                                    'orientation'   =>  ""
                                   ); 

$chart [ 'axis_category' ] = array (   'skip'         =>  0,
                                       'font'         =>  "Arial", 
                                       'bold'         =>  true, 
                                       'size'         =>  0, 
                                       'color'        =>  "black", 
                                       'alpha'        =>  0,
                                       'orientation'  =>  "horizontal"
                                   ); 

                                      
$chart [ 'chart_value' ] = array (  'prefix'         =>  "", 
                                    'suffix'         =>  "", 
                                    'decimals'       =>  0,
                                    'decimal_char'   =>  ".",  
                                    'separator'      =>  "",
                                    'position'       =>  "outside",
                                    'hide_zero'      =>  false, 
                                    'as_percentage'  =>  false, 
                                    'font'           =>  "Arial", 
                                    'bold'           =>  true, 
                                    'size'           =>  9, 
                                    'color'          =>  "black", 
                                    'alpha'          =>  0
                                    
                                    );
                       
           
 $chart [ 'draw' ] = array (

                             
                            array ( 'type'       => "text",
                                    'h_align'    => "center", 
                                    'v_align'    => "middle", 
                                    'x'			 => 200,
                                    'y'			 => 0,
                                    'text'       => $text,  
                                    'font'       => "Arial", 
                                    'bold'       => true, 
                                    'size'       => 20, 
                                    'color'      => "a00000", 
                                    'alpha'      => 90
                                  ),
                             
                            array ( 'type'       => "text",
                                    'h_align'    => "center", 
                                    'x'			 => 200,
                                    'y'			 => 100,
                                    'v_align'    => "middle", 
                                    'text'       => $support,  
                                    'font'       => "Arial", 
                                    'bold'       => true, 
                                    'size'       => 10, 
                                    'color'      => "darkgray", 
                                    'alpha'      => 100
                                  )
                          ); 
                          
   SendChartData ($chart);

exit();
}

// ***************************************************************************
// ***************************************************************************
// LOG FUNCTIONS
// ***************************************************************************
// ***************************************************************************

define('BUSY_SEP1', "-------------------------------------------------------------");
define('BUSY_SEP2', "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -");

function busylog($text, $identer=0, $mailit=false)
{
	global $inis;
	global $busylog;
	static $fn = null;
	static $ident = 0;
	global $busytime; 
	static $lasttime = null;
	static $lastmilli = null;
	
	$sep  = BUSY_SEP1;	
	$sep2 = BUSY_SEP2;	
	
	// First run: get filename from log
	if($fn === null) $fn = logfileinit('busylog', 'logs/busy_log', $sep);
	
	// Mail it when asked for
	if($mailit) errormail($text);
	
	// Logging switched off by name "none".
	if($fn === false) return;

	// Time
	$now = time(); if($lasttime === null) $lasttime = $now;
	list($usec ,$sec ) = explode (" " ,microtime ()); 
	$micronow = sprintf("%02d%03d", $usec, $sec);
	$milli = $sec . substr($usec,2,3);
	if($lastmilli === null) $lastmilli = $milli;
	$millidiff = $milli - $lastmilli;
	$millidiff = sprintf("%04d", $millidiff);
	$time = sprintf("%03d", $now - $busytime);
	$timediff = sprintf("%02d", $now - $lasttime);
	$lasttime = $now;
	$lastmilli = $milli;
	// take of that bunch above ($time, $timediff, $micronow)
	$showtime = $millidiff;
	// debug microtime() . " . " . $millidiff;

	// Format text
	if($identer < 0) $ident += $identer; // sic +=
	$pad = str_repeat("   ", max($ident, 0));
	if($identer > 0) $ident += $identer;
	if(!$text) return; // but the indents handled.
	
	$text = $pad . $text . "\r\n"
		 . (($ident <= 0) ? "$sep\r\n" : "")
		 . (($ident == 1) ? "$sep2\r\n" : "");

	$busylog .= $showtime . " " . $text;

	if($fp = @fopen($fn, "a"))
	{
		$written = @fwrite($fp, $text);
		@fclose($fp);
	
		if($written != strlen($text))
			errormail('Log file $fn: write problem.\n\nTried to write:\n\n$text.');
	}
	
	// debug echo("<br>" . $busylog . "<br>");
}

function logfileinit($entry, $fn, $sep="")
{
		global $inis;

		// Check writeability
		// note: is_writeable() ignores safemode settings.
		// We try for real.
		if($fn && !file_exists($fn))
		{
			$fp = fopen($fn, "w");
			if (!$fp) 
				errormail("Logfile $fn could not be created.");


			fwrite($fp, PROGRAM . " " . VERSION . " " . COPYRIGHT . "\n"
					. ($sep ? $sep . "\r\n" : ""));
			fclose($fp);
			clearstatcache();
			if (!file_exists($fn)) 
				errormail("Logfile $fn could not be initialized.");
		}

		return $fn;
}

function errormail($text)
{
		global $inis;
		static $spamprotect = 0;
		$spamlimit = 3;
		
		if($spamprotect++ > $spamlimit) return;
		if($spamprotect == $spamlimit) $text = "Stopped additional error mails for this call.";

		if(isset($inis) && isset($inis['LOGS']) &&
		isset($inis['LOGS']['errormail']))
			$to = $inis['LOGS']['errormail'];
		else
			return;

		if(!$to || strtolower($to) == 'none') 
			return;
				
		mail($to, PROGRAM . " " . VERSION . ": ERROR", $text);
}

function dumpbusysnap($comment, $echo=true, $write=false)
{	
	global $busylog;
	
	$tx = htmlentities($busylog);
	$tx = str_replace("  ", " &nbsp;", $tx);
	$tx = preg_replace("/(?<!-)---(?!-)/", "<hr>", $tx);
	$tx = preg_replace("/http[^\s']+/i", "<a href=\\0 target=_blank>\\0</a>", $tx);
	$tx = nl2br($tx);

	$tx = "<hr>$tx";
	$tx .= "<hr>Notes:<br>" . note() ."-";

	if($echo) echo($tx);
	
	if($write)
	{
		// Replace - - - - 
		$tx = str_replace(BUSY_SEP1 . "<br />", "<hr class=sep1>", $tx);
		$tx = str_replace(BUSY_SEP2 . "<br />", "<hr class=sep2>", $tx);
	
	
		// Add style sheet, header, explanation
		$tx = '<link rel="stylesheet" type="text/css" href="'.BUSY_SNAP_STYLE.'">'
			. "<h1>Last Calculation: $comment</h1>" 
			. "<p class=nonuserwarning>You should not usually need to review the following data. This is the trace of the data accumulation of the last requested chart or list.</p>"
			. "<div class=logdata>"
			. $tx
			. "</div>";
	
		$filetime = file_exists(BUSY_SNAP) ? filemtime(BUSY_SNAP) : 0;
	
		$append = (time() - $filetime < 30);
		$fp = fopen(BUSY_SNAP, $append ? "a" :"w") ;
		fwrite($fp, $tx);
		fclose($fp);
	}
}

function displaybusylog()
{
		$fp = fopen("logs/busy", "r"); /// dont hardcode
		$tx = fread($fp, min(1000000, filesize("logs/busy")));
		fclose($fp);

		// Replace - - - - 
		$tx = str_replace(BUSY_SEP1 . "<br />", "<hr class=sep1>", $tx);
		$tx = str_replace(BUSY_SEP2 . "<br />", "<hr class=sep2>", $tx);
	
		// Add style sheet, header, explanation
		$tx = '<link rel="stylesheet" type="text/css" href="'.BUSY_SNAP_STYLE.'">'
			. "<h1>Last Calculation</h1>" 
			. "<p class=nonuserwarning>You should not usually need to review the following data. This is the trace of the data accumulation of the last requested chart or list.</p>"
			. "<div class=logdata>"
			. $tx
			. "</div>";

		echo($tx);
}

function hidepw($url)
 // hide passwd in URL string, replace w/***
{
	return $url;
	return preg_replace("/:[^:@]+@/", ":***@", $url);
}

function note($text = null)
// Notes "object" usage:
// note("...") add ... to note
// note("reset") reset notes
// note() get notes
{
	static $notes = "";
	
	if($text === null)
		return $notes;
	else if($text == "reset")
		$notes = "";
	else
		$notes .= $text . "\n";
}

function sendtostatusbar($text="Ready", $flashbar = null)
{
/*
	if($flashbar == BLUEFLASH)
		$text = livebarsource() . $text;
	if($flashbar == REDFLASH)
		$text = livebarsource("brown", "red") . $text;
*/
	$user = $_SERVER['REMOTE_USER'];
	$fn = statusfilename($user);
	$fp = fopen($fn, "w");
	fwrite($fp, $text);
	fclose($fp);
}

// ***************************************************************************
// ***************************************************************************
// INI FUNCTIONS
// ***************************************************************************
// ***************************************************************************

function pulldefinition($def, $clearfn, $fn, $ini, $section, $value, $min=null, $max=null, $default=null)
// Take definition entry from ini, test range, set default if missing.
// Makes sure the definition exists after called.
// Dies if out of range encountered, or missing in ini and no default given.
// Default can not be null.
{
	if(!isset($ini[$section]) && $default === null)
		die("Missing '$section' section in $clearfn '$fn'.");
	if(!isset($ini[$section][$value]) && $default === null)
		die("Missing definition for '$value' in '$section' section in $clearfn '$fn'" 
			. ($min !== null ? " Min: $min" : "")
			. ($max !== null ? " Max: $max" : "")
			. ($max !== null ? " Recommended: $default" : "") 
			. ".");
			
	if(isset($ini[$section][$value]))
	{
		$x = $ini[$section][$value];

		if($x === "off" || $x === "no" || $x === "none" || $x === "disabled")
			$x = false;
		if($x === "on" || $x === "yes" || $x === "enabled")
			$x = true;

		if($min !== null && $min > $x)
			die("Definition for '$value' in '$section' section in $clearfn '$fn' too small ($x). Min value: $min."); 
		if($max !== null && $max < $x)
			die("Definition for '$value' in '$section' section in $clearfn '$fn' too big ($x). Max value: $max."); 

		define($def, $ini[$section][$value]);

	}
	else
		define($def, $default);

}

function buildsourcegrid($verbose=false, $test=false)
{
	global $inis;
	global $serverinis;
	global $clientifn;
	global $serverifn;
	// DEBUG print_r($inis);

	global $sourcegrid;
	global $scangrid;
	global $evalgrid;

	$sourcegrid = array(); // serves as signal for getvalidindexes()
	$scangrid = array();
	$evalgrid = array();
	
	if($verbose) startsheet();

	if($verbose) echo("<h1>Scan Definitions</h1>");

	if($verbose && $test) echo("<div class=logmessagehead>");
	if($verbose && $test) messageplaceholder("Tests not complete.");
	if($verbose && $test) echo("</div>");

	# Scanner data
	# results into
	# scangrid[]

	if($verbose) echo("<h2>Scanner</h2>");
	if($verbose) echo("<p>From $serverifn</p>");
	foreach($serverinis as $key => $sectiondata)
	{
		$key = trim($key);
		if(strpos($key, "SCANNER") === 0)
		{
			preg_match("/SCANNER\s*(.*)/", $key, $match);
			$id = $match[1];
			$scangrid[$id] = $sectiondata;

			if($verbose) echo("<h3>$id</h3>");
			if($verbose) printtable($scangrid[$id], "tests");

			// Tests pattern on given sample, if defined
			if($test)
				foreach($scangrid[$id] as $key => $s)
					if(isset($scangrid[$id][$key . "Sample"]))
						runSample($key, $scangrid[$id][$key], $scangrid[$id][$key . "Sample"]);
			// Tests group grepping on sample files, if all defined
			if($test)
				if(isset($scangrid[$id]["samplefiles"]))
					foreach($scangrid[$id] as $key => $s)
						if(isset($scangrid[$id][$key . "Start"])
						&& isset($scangrid[$id][$key . "End"]))
				
							runSampleFilesForGroups($key, 
								$scangrid[$id]["samplefiles"],
								$scangrid[$id][$key],
								$scangrid[$id][$key . "Start"],
								$scangrid[$id][$key . "End"],
								$id
								);
		}
	}

	// debug print_r($scangrid);



	# Source data
	# results into
	# sourcegrid[]

	if($verbose) echo("<h2>Sources</h2>");
	if($verbose) echo("<p>From $clientifn</p>");
	foreach($inis as $key => $sectiondata)
	{
		$key = trim($key);
		if(strpos($key, "SOURCE") === 0)
		{
			preg_match("/SOURCE\s*(.*)/", $key, $match);
			$id = $match[1];
			$sourcegrid[$id] = $sectiondata;
			
			// is copied, not just referenced by php.

			if($verbose) echo("<h3>$id</h3>");
			
			if($verbose) printtable($sourcegrid[$id], "tests");

			if(isset($sourcegrid[$id]['end']) && trim($sourcegrid[$id]['end']) == "*")
				$sourcegrid[$id]['end'] = makemonthtag(time());

		}
	}


	# Presets definitions
	# results into
	# evalgrid[id][name]		human readable name
	# evalgrid[id][scannerid]	scanner to be used
	# evalgrid[id][patternid]	pattern id in scanner definition
	# evalgrid[id][tag]			search 'anchor' in regex pattern
	# evalgrid[id][pattern]		regex scan pattern
	# or
	# evalgrid[id][error]		error message

	
	if($verbose) echo("<h2>Presets</h2>");
	if($verbose) echo("<p>From $clientifn</p>");
	$evalgrid = array();
	
	if(isset($inis['PRESETS']) && count($inis['PRESETS']))
	{
	  foreach($inis['PRESETS'] as $id => $definition)
	  {
		if(preg_match("/([^:]+): \s* ([^, ]+)\s(alternate\s)*([^,]+), (.+)/x", $definition, $match))
		{
			$name      = trim($match[1]);
			$scannerid = trim($match[2]);
			$alternate = trim($match[3]);
			$patternid = trim($match[4]);
			$tag       = trim($match[5]);
			$pattern   = makePattern($scannerid, $patternid, $tag);

			$evalgrid[$id]['name']      = $name;
			$evalgrid[$id]['scannerid'] = $scannerid;
			$evalgrid[$id]['alternate'] = $alternate ? "yes" : "no";
			$evalgrid[$id]['patternid'] = $patternid;
			$evalgrid[$id]['tag']       = $tag;
			$evalgrid[$id]['pattern']   = $pattern;
		}
		else
		{
			$evalgrid[$id]['error'] = "Pattern Definition Error";
		}
		if($verbose) echo("<h3>$id</h3>");
		if($verbose) printtable($evalgrid[$id], "tests");
		
		if($test)
			runSampleFiles($scangrid[$scannerid]['samplefiles'], $pattern, $scannerid, $patternid);
	  }
	}
	
	if($verbose && $test) testerror("verdict"); // flag to print out results

	if($verbose) visibilitycontrol("writescript"); // flag to write java script
	
	if($verbose) endsheet();

}

function makePattern($scannerid, $patternid, $tag)
{
	global $scangrid;
	if(!isset($scangrid[$scannerid][$patternid]))
		return "Undefined Scanpattern Scanner $scannerid, Pattern $patternid.";
	
	$pattern = $scangrid[$scannerid][$patternid];

	$pattern = translatePattern($pattern, $tag);

	return $pattern;
}

function masterPattern($pattern)
{
	return "/^.*".$pattern.".*$/mi";
}

function translatePattern($pattern, $tag = "")
// some calls don't contain TAG, like start and end of group
{
	$pattern = str_replace("TAG", "(?:$tag)", $pattern); // ?: == non capturing
	$pattern = str_replace("...", ".*", $pattern);       
	$pattern = str_replace(" ", "[ \t]+", $pattern);
	$pattern = str_replace("%d", "\d+", $pattern);
	$pattern = str_replace("%a", "[\w\d.,_'/-]+", $pattern);
	$pattern = str_replace("%l", "[^\n]+", $pattern);
	$pattern = str_replace("%s", "[^.\n]+", $pattern);
	$pattern = str_replace("(%p)", "([\d.,-]+)[ \t]*%", $pattern);
	$pattern = str_replace("%p", "[\d.,-]+[ \t]*%", $pattern);

	return $pattern;
}

function printmulticolumntable($a, $class="", $columnhelp=false)
// expects
// a[0]		first column (headers)
// a[1]		first value column, header in [1][0]
// + ... optional a[2] ... header in [2][0] 
// etc
{
	if(!$a) $a = array(array("-" => "")); // for consistent output formatting.
			
	$ncolumns = count($a);
	$nrows = count($a[0]);
	
	echo "\n\t<table class=$class>\n";

	for($ir = 0; $ir < $nrows; $ir++)
	{
		echo "\t\t<tr>\n";	

		for($ic = 0; $ic < $ncolumns; $ic++)
		{
			$head  = ($ic == 0 || $ir == 0);
			$emin  = $head ? "<b>" : "";
			$emout = $head ? "</b>" : "";				
			$align = ($ic == 0) ? "left" : "right";
			$value = $a[$ic][$ir];
			if($ic == 0 && $ir == 0) $value = ""; // max val for charts

			if(!preg_match("/(.+)\s(\d\d)$/", $value, $match))
				echo "\t\t\t<td style=padding-left:6; align=$align colspan=2>$emin$value$emout</td>\n";	
			else
			{
				$value1 = $match[1];
				$value2 = $match[2];
				echo "\t\t\t<td align=left colspan=1>$emin$value1$emout</td><td align=right colspan=1>$emin$value2$emout</td>\n";	
			}
		}
		echo "\t\t</tr>\n";	
	}

	echo "\t</table>\n\n";
}



function gracefuldeath($text)
{
	echo "<a href=index.php><img src=images/photon.logo.2.1-sq100-tx-b3.jpg border=0></a><br>";
	echo($text);
	exit();
}

function prettycaps($result)
{
			// Pretty caps
			if(!preg_match("/a|e|i|o|u/i", $result))
				$result = strtoupper($result);
			else
			{
				/*
				$result = str_replace("-", " - ",$result);
				$result = str_replace(".", " . ",$result);
				$result = str_replace("_", " - ",$result);
				$result = ucwords($result);
				$result = str_replace(" - ", "-",$result);
				$result = str_replace(" . ", ".",$result);
				*/
				$result = str_replace("-", " ",$result);
				$result = str_replace(".", " ",$result);
				$result = str_replace("_", " ",$result);
				$result = ucwords($result);
			}
			return $result;
}

function prettypattern($result)
{
			$result = preg_quote($result, "/");
			$result = str_replace("-", ".",$result);
			$result = str_replace(" ", ".",$result);
			$result = str_replace("_", ".",$result);

			return $result;
}

function getTitle($url)
{
	$src = @file_get_contents($url);
	
	if($src)
		if(preg_match("/<title>(.*)<\/title>/i", $src, $match))
			return $match[1];

	return "";			
}

function sprintfsourceurl($url, $tag)
{
			$yyyy = substr($tag, 0, 4);
			$mm = substr($tag, 4, 2);
			$m = $mm + 0;
			
			$url = str_replace("%yyyy", $yyyy, $url);
			$url = str_replace("%mm", $mm, $url);
			$url = str_replace("%m", $m, $url);
			
			return $url;
}

function macflush()
{
	echo(str_repeat(" ", 1024));
	echo("\n");
	flush();

}

function grepSE($host)
{
	$search_term = SEARCH_ENGINE_SEARCH_TERM;
	$search_term = str_replace("(", "\"", $search_term); 
	$search_term = str_replace(")", "\"", $search_term);
	// ((5)) < > is php ini shortfall. Can't scan " ... \"...\" ... "
	$search_term = urlencode($search_term);
	$url = SEARCH_ENGINE_QUERY;
	$url = str_replace("%host%", $host, $url);
	$url = str_replace("%search_term%", $search_term, $url);
	// debug echo htmlentities("url:$url term: $search_term regex:".SEARCH_ENGINE_URL_SCAN_PATTERN);

	$src = @file_get_contents($url);
	if(!$src) return GET_ERROR;

	if(preg_match_all(SEARCH_ENGINE_URL_SCAN_PATTERN, $src, $matches))
	{
		$finds = array();
		;
		foreach($matches[1] as $find)	
			$finds[] = strip_tags($find);
		return $finds;
	}
	else
		return NO_FINDS;

}

function useSE()
{
	if(SEARCH_ENGINE_NAME
		&& SEARCH_ENGINE_QUERY
		&& SEARCH_ENGINE_URL_SCAN_PATTERN
		&& SEARCH_ENGINE_SEARCH_TERM)
		return true;
	return false;
}

function colorsample($i, $meetsthreshold = true)
{
	if($meetsthreshold)	$c = color($i);
	else $c = color(-1);
	
	return("<span style='background-color:#$c'> &nbsp;&nbsp;&nbsp;&nbsp; </span>");

}

function includestyle()
{
	?>
	<link rel="stylesheet" type="text/css" href="style.css">
	<?
}

function cbc_encrypt($tx)
{
	$keyseed = "Photon";
	$ivseed  = "Photon";
	$prefix  = "RQC1:"; 
	$suffix  = "";
	
     $td = mcrypt_module_open(MCRYPT_BLOWFISH, '' ,MCRYPT_MODE_CBC,''); 
     $ks = mcrypt_enc_get_key_size($td); 

     $key = substr(md5($keyseed), 0, $ks); 
     $iv  = substr(md5($ivseed), 0, mcrypt_enc_get_iv_size($td)); 

     mcrypt_generic_init($td, $key, $iv); 
     $encrypted = mcrypt_generic($td, $tx); 

     mcrypt_generic_deinit ($td); 
     mcrypt_module_close ($td); 

	 return $prefix . $encrypted . $suffix;
}

function phone($level, $activity, $detail="")
{

	// In case of early call by error handler:
	$phone_home  = (defined('PHONE_HOME' ) ? PHONE_HOME  : true);
	$phone_level = (defined('PHONE_LEVEL') ? PHONE_LEVEL : 4   );
	$phone_anonymization =
		(defined('PHONE_ANONYMIZATION') ? PHONE_ANONYMIZATION : true );
	$phone_encryption = 
		(defined('PHONE_ENCRYPTION'   ) ? PHONE_ENCRYPTION    : false);
	
	// Switched off
	if(!$phone_home) return;
	
	// Decide on level
	if($phone_level == 1)
		if($level != 1 && $level != 4) return;
	if($phone_level == 2)
		if($level > $phone_level && $level != 4) return;
	if($phone_level == 4)
		if($level != $phone_level) return;

	$start 			= "RQP";
	$end 			= "RQP";
	$logformat 		= 1;
	$loglevel 		= $level;
	$cryptformat 	= 1;
	$time 			= logharden(gmdate("Y m d H:i:s") . " " . date("(T O)"));
	$server 		= logharden($_SERVER["SERVER_NAME"]);
	$installation 	= logharden($server . "//" .
								dirname($_SERVER["SCRIPT_NAME"]));
	$client 		= logharden("Testclient");
	$user 			= logharden(isset($_SERVER["REMOTE_USER"]) ? $_SERVER["REMOTE_USER"] : "not logged in");
	$activity		= logharden($activity);
	$script 		= logharden(basename($_SERVER["SCRIPT_NAME"]));
	$parameter 		= logharden($_SERVER["QUERY_STRING"]);
	$cookies 		= ""; foreach($_COOKIE as $k=>$v) $cookies .= "$k: $v;";
	$cookies 		= logharden($cookies);
	$software 		= logharden($_SERVER["SERVER_SOFTWARE"]);
	$browser 		= logharden(isset($_SERVER["HTTP_USER_AGENT"]) ? $_SERVER["HTTP_USER_AGENT"] : "n.a.");
	$detail			= logharden($detail);
	
	if($level > 2)
		$software = $browser = "~";
	
	if($phone_anonymization)
	{
		$salt = $server;
		$installation = md5($installation . $salt);
		$client = md5($client . $salt);
		$user = md5($user . $salt);
	}

	$log = "$start\t$logformat\t$loglevel\t$time\t$installation\t$client\t$user\t$activity\t$script\t$parameter\t$cookies\t$software\t$browser\t$detail\t$end";

	if($phone_encryption)
		$log = cbc_encrypt($log);

	$log = urlencode($log);
	$remotecall = "http://photon.authinc.com/phone.php?$log";
	
	$ok = file_get_contents($remotecall);

	// echo($remotecall . "<br><br>");
	// echo($ok. "<br><br>");

}

function ssl_encrypt($source)
{
$pubx509 = "-----BEGIN CERTIFICATE-----
MIICijCCAfOgAwIBAgIBADANBgkqhkiG9w0BAQQFADCBijELMAkGA1UEBhMCWFgx
DjAMBgNVBAgTBVN0YXRlMRYwFAYDVQQHEw1Tb21ld2hlcmVDaXR5MQ8wDQYDVQQK
EwZNeVNlbGYxETAPBgNVBAsTCFdoYXRldmVyMQ8wDQYDVQQDEwZteVNlbGYxHjAc
BgkqhkiG9w0BCQEWD3VzZXJAZG9tYWluLmNvbTAeFw0wNTEyMDQxMjEwNTZaFw0w
NjEyMDQxMjEwNTZaMIGKMQswCQYDVQQGEwJYWDEOMAwGA1UECBMFU3RhdGUxFjAU
BgNVBAcTDVNvbWV3aGVyZUNpdHkxDzANBgNVBAoTBk15U2VsZjERMA8GA1UECxMI
V2hhdGV2ZXIxDzANBgNVBAMTBm15U2VsZjEeMBwGCSqGSIb3DQEJARYPdXNlckBk
b21haW4uY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCjV7w9f9opzqva
ENsbXWOZ21t/E1Pr2oWH+ZnacgZNs4PwekKq0AX+QKclM1kFglB/ePXjlIihcB1x
ArcjXesGlfd2sDTMyk7puRifuTjjrNs0TbL1N33Qd7scc9N/D+XT+0US10v2RLlb
dJ6bxNARUgv5dthD9vRKafx5CODynwIDAQABMA0GCSqGSIb3DQEBBAUAA4GBAJmH
SZrWTjt9f+mZsJcOBPsoBiB/KPCxnc2SMQ4kPHulBn1C8VKh8Bs6uiryHXRjAZQr
C7dIfb6+g6/sxgrV/he2BTTEbixJ3FHi99b4Z1Jlg/WmdNylYTDH3zDKhJDCQLr0
SaeLFMxNWT21YwDBr1VLPASMr4aLCmxqsg9MqBzd
-----END CERTIFICATE-----";

	$pubkey = openssl_pkey_get_public($pubx509);

	$maxlength=117;
	$output='';
	while($source)
	{
		$input= substr($source,0,$maxlength);
		$source=substr($source,$maxlength);
		$ok= openssl_public_encrypt($input,$encrypted,$pubkey);
		if(!$ok) die("Crypterror");
		$output.=$encrypted;
	}
	$output = "RQC2:" . $output . "RQC";

	return $output;
}


function logharden($tx)
{
	return str_replace("\t", " ", $tx);
}

// ***************************************************************************
// ***************************************************************************
// LANGUAGE FUNCTIONS
// ***************************************************************************
// ***************************************************************************

function I($t)
{	
	if(LANGUAGE == "english")
		return  $t;

	static $lang = null;
	$fn = languagefilename();
	
	// Ini once:
	if($lang === null)
	{
		if(!file_exists($fn))
		{
			$lang = array();
		
			busylog("NOTE: LANGUAGE FILE $fn not found.");
		}
		else
		{
			$langfile = file($fn);
			$lang = array();
			foreach($langfile as $line)
				if(preg_match("/(.*) :: (.*)/", $line, $match))
					$lang[trim($match[1])] = trim($match[2]);
		}
	}
	
	if(isset($lang[$t]))
		if(trim($lang[$t]) != "?")

			// Found, return
			return $lang[$t];
		else
			;
	else if(APPEND_MISSING_LANGUAGE_ENTRIES)
	{
		
		// Write empty entry
		$fp = fopen($fn, "a");
		fwrite($fp, "\n$t :: ?");
		fclose($fp);
		$lang[$t] = "?"; // signal for (3) not to write again.
						 // Absolutely concurrent users may have this happen.
	}
	
	return $t;
}

function languagefilename()
{
	return 	"int/" . LANGUAGE . ".lang";
}



// ***************************************************************************
// ***************************************************************************
// NOTES
// ***************************************************************************
// ***************************************************************************


/*	Appendix 

	Compendium format

	$refcompendium['version']				 = <compendium version>
												0.9.98: 1

	$refcompendium[id]['name']				 = <clearname (now same as id)>
												0.9.98
	$refcompendium[id]['hosts'][host]['sum'] = <total referrals from this host>

	$refcompendium[id]['urls'][url]['sum']   = <total referrals from this url>
	$refcompendium[id]['urls'][url]['met']   = <count of months url was listed> 
	$refcompendium[id]['urls'][url]['pattern']  = <*id* as pattern. not used.>

	$refcompendium[id]['sum']				 = <total count for this id>
	$refcompendium[id][tag]					 = <monthly count for this id>

*/
