<?
/*	Photon
	statusbar.php

	Selfrefreshing load status indicator,
	gauge and current action.
	
	(c) 2005 Red Quant Corporation
	Licensed under the Open Software License version 2.1 
	See file LICENSE in the root folder of this distribution

*/	

define('STATUS_RELOAD_FREQUENCY', 100); // times.
// Makes an ugly white flash but needs be to not clog the browser.
define('STATUS_IDLE_SPEED', 1.5); // seconds
define('STATUS_ACTIVE_SPEED', 0.5); // seconds

?>
<head>
<meta time=<? echo date("H:i:s") ?>>
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="pragma" content="no-cache">
<link rel="stylesheet" type="text/css" href="style.css">
<title>Photon Statusbar</title>
</head>
<body style='margin:1;margin-left:20;'>

<?
include("globals.php");
if(!file_exists(SETUP_COMPLETED_ONCE_FLAG_FILE))
	exit();

?>


	<? echo livebarsource() ?>
	<span id=bar>...</span>

	<script>
	x = document.getElementById('bar');
	function writebar(text, color) { x.innerHTML = text; xbarcolor = color;}
	writebar("Ready");
	</script>

<?

	// Prep
	if(!isset($_SERVER['REMOTE_USER']))
		$tx = "Not logged in.";
	else
	{
		$user = $_SERVER['REMOTE_USER'];
		$fn = statusfilename($user);
	}
	
	// Loop
	$counter = 0;
	$lasttext = "";
	while($counter++ <= STATUS_RELOAD_FREQUENCY)
	{
		if(file_exists($fn))
			$tx =  file_get_contents($fn);
		else	
			$tx = "";
	
		// DEBUG $tx = date("s") . ":" . $tx;
		if($tx && $tx == $lasttext) $color = "red";
		else $color = "blue";
	
		echo "<script>writebar('" . $tx . "', '$color')</script>\n";
		flush();
	
		echo str_repeat(" ", 4096); // Safari fix, http://de3.php.net/flush
		flush();
	
		$lasttext = $tx;
		usleep($tx ? (STATUS_ACTIVE_SPEED * 1000000) : (STATUS_IDLE_SPEED * 1000000));

	
	}

	// Reload
	?>
	<script>
	location.reload();
	</script>
	<?
?>
</body>

<?
function livebarsource($dim="darkblue", $light="blue")
{

	$source = "
		<span id=ra0 style='color:$dim'>&bull;</span>
		<span id=ra1 style='color:$dim'>&bull;</span>
		<span id=ra2 style='color:$dim'>&bull;</span>
		<span id=ra3 style='color:$dim'>&bull;</span>
		<span id=ra4 style='color:$dim'>&bull;</span>
		
		<script>
		xbarcolors = Array();
		xbarcolors['blue'] = Array();
		xbarcolors['red' ] = Array();
		xbarcolors['blue']['dim']   	= 'midnightblue';
		xbarcolors['blue']['light'] 	= 'blue';
		xbarcolors['red' ]['dim']   	= 'brown';
		xbarcolors['red' ]['light'] 	= 'red';
		xbarcolor = 'blue';
		
		xbar = Array();
		xbar[0] = document.getElementById('ra0');
		xbar[1] = document.getElementById('ra1');
		xbar[2] = document.getElementById('ra2');
		xbar[3] = document.getElementById('ra3');
		xbar[4] = document.getElementById('ra4');
		
		xbari = 0;
		function gaugelife()
		{
			xbar[xbari++].style.color = xbarcolors[xbarcolor]['dim'];
			if(xbari>4) xbari = 0;
			xbar[xbari].style.color = xbarcolors[xbarcolor]['light'];
		}

		window.setInterval(\"gaugelife()\",100); 
		
		</script>
	";

	return $source;
}
?>